/****************************************************************************
"QueData" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function QueData()
{
	this.m_Cmd		= null;
	this.m_Id		= null;
	this.m_Path		= null;
	this.m_Document	= null;
	this.m_Icon		= null;
	this.m_Handle	= null;

	// メンバ変数
	var		m_Self				= this;
	
// private function define

// public functions define
//=======================================================================
//!	dataの作成
//!	@retval			---
//-----------------------------------------------------------------------
this.GetData = function()
{
	if( m_Self.m_Cmd == "new" )
	{
		return "cmd=new&id=" + m_Self.m_Id 
			+ "&path=" +m_Self. m_Path 
			+ "&document=" + m_Self.m_Document 
			+ "&icon=" + m_Self.m_Icon 
			+ "&open=" + m_Self.m_Handle;
	}
	else if( m_Self.m_Cmd == "update" )
	{
		return "cmd=update&id=" + m_Self.m_Id
			+ ( ( m_Self.m_Path != null ) ? ( "&path=" + m_Self.m_Path ) : "" )
			+ ( ( m_Self.m_Document != null ) ? ( "&document=" + m_Self.m_Document ) : "" )
			+ ( ( m_Self.m_Icon != null ) ? ( "&icon=" + m_Self.m_Icon ) : "" )
			+ ( ( m_Self.m_Handle != null ) ? ( "&open=" + m_Self.m_Handle ) : "" );
	}
	else if( m_Self.m_Cmd == "delete" )
	{
		return "cmd=delete&id=" + m_Self.m_Id;
	}
	else if( m_Self.m_Cmd == "gettree" )
	{	
		return "cmd=gettree";
	}
	else if( m_Self.m_Cmd == "getdocument" )
	{
		return "cmd=getdocument&id=" + m_Self.m_Id;
	}
}
}


/****************************************************************************
"Storage" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function Storage
		(
		php_path
		)
{
	// イベント
	this.onnew;
	this.onupdate;
	this.ondelete;
	this.ongettree;
	this.ongetdocument;
	this.onerror;
	
	// データ
	var		m_PhpPath			= php_path;
	var		m_Que				= new Array( 0 );
	var		m_ExecuteFlag		= false;
	
	// メンバ変数
	var		m_Self				= this;

// イベントハンドラ
//=======================================================================
//!	OnReceiveRequest
//!	@retval			---
//-----------------------------------------------------------------------
this.OnReceiveRequest = function
		(
		result
		)
{
	// アップデート
	m_ExecuteFlag	= false;
//	alert( result.responseText );

	//エラーチェック
	{
		var		error = result.responseXML.getElementsByTagName('error')
		if( error.length != 0 )
		{
			if( m_Self.onerror != null )
			{
				m_Self.onerror( );
				return;
			}
		}
	}	
	//shift
	var	que = m_Que.shift();
	
	// event
	if( que.m_Cmd == "new" )
	{
		if( m_Self.onnew != null )
			m_Self.onnew( que.m_Id );
	}
	else if( que.m_Cmd == "update" )
	{
		if( m_Self.onupdate != null )
			m_Self.onupdate( que.m_Id );
	}
	else if( que.m_Cmd == "delete" )
	{
		RemoveId( que.m_Id );
		if( m_Self.ondelete != null )
			m_Self.ondelete( que.m_Id );
	}
	else if( que.m_Cmd == "gettree" )
	{
		if( m_Self.ongettree != null )
			m_Self.ongettree( AnalizeGetTree( result ) );
	}
	else if( que.m_Cmd == "getdocument" )
	{
		if( m_Self.ongetdocument != null )
			m_Self.ongetdocument( que.m_Id , AnalizeGetDocument( result ) );
	}
	//次のコマンドを実行する
	m_Self.Execute();
}	
// private function define
//=======================================================================
//!	analize gettree
//!	@retval			---
//-----------------------------------------------------------------------
function AnalizeGetTree
		(
		result
		)
{
/*
<tree>
	<item id="??" icon="??" open="true/false">
		<path>
		</path>
	</item>
	...
</tree>
*/
	var		items = result.responseXML.getElementsByTagName('item');
	var		off , num = items.length;
	var		ids 	= new Array( num );
	var		icons	= new Array( num );
	var		opens	= new Array( num );
	var		paths	= new Array( num );
	for( off = 0 ; off < num ; off++ )
	{
//		ids[ off ]		= items[ off ].attributes[ "id" ].nodeValue;
//		icons[ off ]	= items[ off ].attributes[ "icon" ].nodeValue;
//		opens[ off ]	= items[ off ].attributes[ "open" ].nodeValue;
		ids[ off ]		= items[ off ].attributes[ 0 ].nodeValue;
		icons[ off ]	= items[ off ].attributes[ 1 ].nodeValue;
		opens[ off ]	= items[ off ].attributes[ 2 ].nodeValue;
		
		for( c = 0 ; c < items[ off ].childNodes.length ; c++ )
		{
			if( items[ off ].childNodes[ c ].tagName == "path" )
			{
				var	path	= items[ off ].childNodes[ c ]; 
				paths[ off ] = path.firstChild.nodeValue;
			}
		}
	}
	
	var		it = new Array( 5 );
	it[ 0 ]	= "root";
	it[ 1 ]	= 0;
	it[ 2 ]	= true;
	it[ 3 ] = "root_id";
	it[ 4 ]	= null;
	for( off = 0 ; off < num ; off++ )
	{
		path = paths[ off ].split( "\n" );
		var		now = it;
		for( p_off = 0 ; p_off < path.length ; p_off++ )
		{
			if( now[ 4 ] == null )
				now[ 4 ] = new Array( 0 );

			var		f = false;
			for( t = 0 ; t < now[ 4 ].length ; t++ )
			{
				if( now[ 4 ][ t ][ 0 ] == path[ p_off ] )
				{
					now = now[ 4 ][ t ];
					f = true;
					break;
				}
			}
			if( f == false )
			{
				var		new_item = new Array( 5 );
				new_item[ 0 ]	= path[ p_off ];
				new_item[ 1 ]	= 0;
				new_item[ 2 ]	= true;
				new_item[ 3 ]	= "";
				new_item[ 4 ]	= null;
				now[ 4 ].push( new_item );
			
				now = new_item;
			}
		}
		// setting
		now[ 1 ] = icons[ off ];
		now[ 2 ] = opens[ off ];
		now[ 3 ] = ids[ off ];
	}
	return it;
}
//=======================================================================
//!	analize getdocument
//!	@retval			---
//-----------------------------------------------------------------------
function AnalizeGetDocument
		(
		result
		)
{
/*
<document>
	HTMLのドキュメント
</document>
*/
	var		docs = result.responseXML.getElementsByTagName('document');
	if( docs[ 0 ].firstChild == null )
		return "";
	return docs[ 0 ].firstChild.nodeValue;

}
//=======================================================================
//!	remove id
//!	@retval			---
//-----------------------------------------------------------------------
function RemoveId
		(
		id
		)
{
	var		off , num = m_Que.length;
	for( off = 0 ; off < num ; off++ )
	{
		if( m_Que[ off ].m_Id == id )
			m_Que[ off ].m_Id = null;
	}
}
// public functions define
//=======================================================================
//!	execute command
//!	@retval			---
//-----------------------------------------------------------------------
this.Execute	= function()
{
	if( m_ExecuteFlag == true )
		return;
	if( m_Que.length == 0 )
		return;
		
	
//	alert( m_Que[ 0 ].GetData() );
//	alert( encodeURI( m_Que[ 0 ].GetData() ) );
	requestFile( "POST" , encodeURI( m_Que[ 0 ].GetData() ) , m_PhpPath , this.OnReceiveRequest , true );
//	requestFile( "POST" , m_Que[ 0 ].GetData() , m_PhpPath , this.OnReceiveRequest , true );
	
	m_ExecuteFlag	= true;	
}
//=======================================================================
//!	Queが存在するか調べる
//!	@retval			---
//-----------------------------------------------------------------------
this.IsQueExist = function()
{
	if( m_Self.m_Que == null )
		return false;
	return m_Self.m_Que.length == 0 ? false : true;
}
//=======================================================================
//!	new
//!	@retval			---
//-----------------------------------------------------------------------
this.New = function
		(
		id , 
		path ,
		doc , 
		icon , 
		handle
		)
{	
	var		que = new QueData();
	que.m_Cmd		= "new";
	que.m_Id		= id;
	que.m_Path		= path;
	que.m_Document	= doc;
	que.m_Icon		= icon;
	que.m_Handle	= handle == false ? 0 : 1;
	m_Que.push( que );
	this.Execute();
}
//=======================================================================
//!	update
//!	@retval			---
//-----------------------------------------------------------------------
this.Update = function
		(
		id , 
		path , 
		doc , 
		icon , 
		handle
		)
{
	var		que = new QueData();
	que.m_Cmd		= "update";
	que.m_Id		= id;
	que.m_Path		= path;
	que.m_Document	= doc;
	que.m_Icon		= icon;
	que.m_Handle	= handle;
	m_Que.push( que );
	this.Execute();
}
//=======================================================================
//!	delete
//!	@retval			---
//-----------------------------------------------------------------------
this.Delete = function
		(
		id
		)
{
	var		que = new QueData();
	que.m_Cmd		= "delete";
	que.m_Id		= id;
	m_Que.push( que );
	this.Execute();
}
//=======================================================================
//!	gettree
//!	@retval			---
//-----------------------------------------------------------------------
this.GetTree = function()
{
	var		que = new QueData();
	que.m_Cmd		= "gettree";
	m_Que.push( que );
	this.Execute();
}
//=======================================================================
//!	getdocument
//!	@retval			---
//-----------------------------------------------------------------------
this.GetDocument = function
		(
		id
		)
{
	var		que = new QueData();
	que.m_Cmd		= "getdocument";
	que.m_Id		= id;
	m_Que.push( que );
	this.Execute();
}
}
