﻿/****************************************************************************
"ExpandView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ExpandView
		(
		open_lt_path , 
		open_ct_path , 
		open_rt_path , 
		open_lc_path , 
		open_cc_path , 
		open_rc_path , 
		open_lb_path , 
		open_cb_path , 
		open_rb_path , 
		close_l_path , 
		close_c_path , 
		close_r_path 
		)
{
	// メンバ変数
	var		m_Open				= true;
	var		m_ImgPath 			= Array
			( 
			open_lt_path , 
			open_ct_path , 
			open_rt_path , 
			open_lc_path , 
			open_cc_path , 
			open_rc_path , 
			open_lb_path , 
			open_cb_path , 
			open_rb_path , 
			close_l_path , 
			close_c_path , 
			close_r_path 
			);
	var		m_Self				= this;
	var		m_HeaderOpenView	= null;
	var		m_HeaderCloseView	= null;
	var 	m_Content 			= null;
	var 	m_Id				= "ExpandView_" + GetUniqueId();

// event functions define
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnHeaderOver = function
		(
		args
		)
{
}
/*==================================================
アイテムを追加する
		return   ---
---------------------------------------------------*/
this.OnHeaderClick = function
		(
		args
		)
{
	if( m_Open == true ) 
		m_Open = false;
	else
		m_Open = true;
	
	// root以下を更新する	
	var		root = document.getElementById( m_Id );
	RemoveChildAll( root );
	if( root != null )
		CreateDomRoot( root );
}

// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDom_line
		(
		root , 			//!< [in] root dom
		image_id , 
		content , 
		click_ck
		)
{
/*
<table cellspacing="0" cellpadding="0" width="100%" border="0">
<tbody>
  <tr>
    <td width="1" background="../img/open_0_0.png" ><img src="../img/open_0_0.png"></td>
    <td background="../img/open_0_1.png">content または <img src="../img/open_0_1.png"></td>
    <td width="1" background="../img/open_0_2.png"><img src="../img/open_0_2.png"></td>
  </tr>
</tbody>  
</table>
*/
	var	table	= root.appendChild( document.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
		table.setAttribute( "width" , "100%" );
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );

	var	tr		= tbody.appendChild( document.createElement( "tr" ) );
	if( click_ck == true )
	{
		tr.style.cursor='pointer';
		tr.onclick = new CallbackAdapt( m_Self.OnHeaderClick ).exec;
		tr.ondblclick = new CallbackAdapt( m_Self.OnHeaderClick ).exec;
	}
	{
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id ] );
		}
		var img		= td.appendChild( document.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id ] );
		}
	}
	{
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "background" , m_ImgPath[ image_id + 1 ] );
		}
		if( content != null && content.CreateDOM != null )
			td.appendChild( content.CreateDOM() );
		else
		{
			var img		= td.appendChild( document.createElement( "img" ) );
			{
				img.setAttribute( "src" , m_ImgPath[ image_id + 1 ] );
			}
		}			
	}
	{
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id + 2 ] );
		}
		var img		= td.appendChild( document.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id + 2 ] );
		}
	}
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomRoot_open
		(
		root			//!< [in] root dom
		)
{
	CreateDom_line( root , 0 , m_HeaderOpenView , true );
	CreateDom_line( root , 3 , m_Content , false );
	CreateDom_line( root , 6 , null , false );
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomRoot_close
		(
		root			//!< [in] root dom
		)
{
	CreateDom_line( root , 9 , m_HeaderCloseView , true );
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomRoot
		(
		root			//!< [in] root dom
		)
{
	if( m_Open == true )
		CreateDomRoot_open( root );
	else 
		CreateDomRoot_close( root );
}

// functions define	
//=======================================================================
//!	contentの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetContent = function
		(
		header_open_view , 
		header_close_view , 
		content_view , 
		open_f
		)
{
	m_HeaderOpenView		= header_open_view;
	m_HeaderCloseView		= header_close_view;
	m_Content 			= content_view;
	m_Open				= open_f;
}
/*==================================================
DOMの獲得
		return   ---
---------------------------------------------------*/
this.CreateDOM = function()
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomRoot( root );
	
	return root;
}
//=======================================================================
//!	SaveCookie
//!	@retval			---
//-----------------------------------------------------------------------
this.SaveCookie = function
		(
		name , 
		day
		)
{
	// oepn状態のセーブ
	if( m_Open == true )
		SetCookie( name + "_open" , "true" , day );
	else
		SetCookie( name + "_open" , "false" , day );
		
	// コンテンツのセーブ
	if( m_Content != null && m_Content.SaveCookie != null )
	{
		m_Content.SaveCookie( name + "_content" , day );
	} 
}
//=======================================================================
//!	LoadCookie
//!	@retval			---
//-----------------------------------------------------------------------
this.LoadCookie = function
		(
		name
		)
{
	// oepn状態のロード
	var		val = GetCookie( name + "_open"  );
	if( val != null )
	{
		if( val == "true" )
			m_Open = true;
		else if( val == "false" )
			m_Open = false;
	}
		
	// コンテンツのロード
	if( m_Content != null && m_Content.LoadCookie != null )
	{
		m_Content.LoadCookie( name + "_content" );
	} 
}
}
