﻿/****************************************************************************
"HtmlView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function HtmlView
		(
		html
		)
{
	// メンバ変数
	var		m_Self				= this;
	var		m_Html				= html;
	var 	m_Id				= "HtmlView_" + GetUniqueId();
	var		m_Doc				= null;
	
// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		root			//!< [in] root dom
		)
{
	root.innerHTML = m_Html;
}

// public functions define
//=======================================================================
//!	DOMの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetDom = function
		(
		dom
		)
{
	m_Dom	= dom;

	// root以下を更新する	
	var		root = m_Doc.getElementById( m_Id );
	RemoveChildAll( root );
	if( root != null )
		CreateDomUnderRoot( root );
}
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}

}
