﻿//=======================================================================
//!	テキストのダウンロード
//!	@retval			---
//-----------------------------------------------------------------------
function HttpRequestText
		(
		filename		//!< [in] パス
		)
{
    var http_obj = createHttpRequest();
    http_obj.open("GET",filename , false );
    http_obj.send( null );
    return http_obj.responseText;
}

//=======================================================================
//! http requestの作成	
//!	@retval			---
//-----------------------------------------------------------------------
function createHttpRequest()
{
	if(window.ActiveXObject)
	{
		try 
		{
			return new ActiveXObject( "Msxml2.XMLHTTP" );
		} 
		catch ( e ) 
		{
			try 
			{
				return new ActiveXObject( "Microsoft.XMLHTTP" );
			} 
			catch ( e2 ) 
			{
				return null;
			}
		 }
	} 
	else if( window.XMLHttpRequest )
	{
		return new XMLHttpRequest();
	} 
	else 
	{
		return null;
	}
}

//=======================================================================
//!	ファイルを読み込む
//!	@retval			---
//-----------------------------------------------------------------------
function requestFile
		( 
		method , 		//"POST" or "GET"
		data , 			//送信するデータ
		fileURL , 		// url
		callback , 		//コールバック関数
		async 			//同期ならfalse
		)
{
	//XMLHttpRequestオブジェクト生成
	var oj = createHttpRequest()
	if( oj == null ) 
		return null

	//ブラウザ判定-->別関数にした方がすっきりする？
	var ua = navigator.userAgent
	var safari	= ua.indexOf("Safari")!=-1
	var konqueror = ua.indexOf("Konqueror")!=-1
	var mozes	 = ((a=navigator.userAgent.split("Gecko/")[1] )?a.split(" ")[0]:0) >= 20011128 
	
	//Konquerorはonloadが不安定http://jsgt.org/ajax/ref/test/response/responsetext/try1.php
	if( window.opera || safari || mozes )
	{
		oj.onload = function () { callback(oj) }
	}
	else
	{
		oj.onreadystatechange =function () 
		{
			if ( oj.readyState == 4 )
			{
				callback(oj)
			}
		}
	}

	//open メソッド
	oj.open( method , fileURL , async )

	
	if(method == 'POST')
	{
		//このメソッドがWin Opera8でエラーになったので、とりあえず分岐2005.5.20
		if(!window.opera)
			oj.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded')
	}

	//send メソッド
	oj.send( data )

}
