﻿var		m_InitMenu 	= false;
var		m_HideMenu	= new Array( 0 );
var		m_MenuCallback	= true;

//=======================================================================
//!	OnBodyClick
//!	@retval			---
//-----------------------------------------------------------------------
function OnBodyClick_menuview()
{
	if( m_MenuCallback == false )
	{
		m_MenuCallback = true;
		return;
	}
	while( m_HideMenu.length != 0 )
	{
		var	func = m_HideMenu.pop();
		if( func != null )
			func();
	}
}	
//=======================================================================
//!	InitializeMenu
//!	@retval			---
//-----------------------------------------------------------------------
function InitializeMenu()
{
	if( m_InitMenu == true )
		return;
	m_InitMenu	= true;
	document.onmousedown=OnBodyClick_menuview;
}
//=======================================================================
//!	RegistHideMenu
//!	@retval			---
//-----------------------------------------------------------------------
function RegistHideMenu
		(
		func
		)
{
	InitializeMenu();
	m_HideMenu.push( func );
}
//=======================================================================
//!	UnregistHideMenu
//!	@retval			---
//-----------------------------------------------------------------------
function UnregistHideMenu
		(
		func
		)
{
	var		off , num = m_HideMenu.length;
	for( off = 0 ; off < num ; off++ )
	{
		if( m_HideMenu[ off ] == func )
		{
			m_HideMenu[ off ] = null;
		}
	}
}
//=======================================================================
//!	hook menu click
//!	@retval			---
//-----------------------------------------------------------------------
function HookMenuClick()
{
	m_MenuCallback	= false;
}

/****************************************************************************
"MenuView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function MenuView
		(
		lt_path , 
		ct_path , 
		rt_path , 
		lc_path , 
		cc_path , 
		rc_path , 
		lb_path , 
		cb_path , 
		rb_path , 
		sd_folder , 
		view
		)
{
	// イベント
	this.onhide			= null;
	
	//リソース
	var		m_ImgPath 			= Array
			( 
			lt_path , 
			ct_path , 
			rt_path , 
			lc_path , 
			cc_path , 
			rc_path , 
			lb_path , 
			cb_path , 
			rb_path 
			);	
	var		m_View				= view;
	var		m_Shadow			= new ShadowView( sd_folder , null );
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "MenuView_" + GetUniqueId();

// event function
//=======================================================================
//!	hide menu
//!	@retval			---
//-----------------------------------------------------------------------
this.OnHideMenu		= function()
{
	m_Self.HideMenu();
}
//=======================================================================
//!	click
//!	@retval			---
//-----------------------------------------------------------------------
this.OnClick		= function
		(
		argc
		)
{
	HookMenuClick();
}
// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDom_line
		(
		tbody , 			//!< [in] parent dom
		image_id , 
		content
		)
{
/*
<table cellspacing="0" cellpadding="0" width="100%" border="0">
<tbody>
  <tr>
    <td width="1" background="../img/open_0_0.png" ><img src="../img/open_0_0.png"></td>
    <td background="../img/open_0_1.png">content または <img src="../img/open_0_1.png"></td>
    <td width="1" background="../img/open_0_2.png"><img src="../img/open_0_2.png"></td>
  </tr>
</tbody>  
</table>
*/
/*
	var	table	= parent.appendChild( document.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
//		table.setAttribute( "width" , "100%" );
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );
*/
	var	tr		= tbody.appendChild( document.createElement( "tr" ) );
	{
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id ] );
		}
		var img		= td.appendChild( document.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id ] );
		}
	}
	{
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "background" , m_ImgPath[ image_id + 1 ] );
		}
		if( content != null && content.CreateDOM != null )
		{
			td.appendChild( content.CreateDOM( document ) );
		}
		else
		{
			var img		= td.appendChild( document.createElement( "img" ) );
			{
				img.setAttribute( "src" , m_ImgPath[ image_id + 1 ] );
			}
		}			
	}
	{
		var	td		= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id + 2 ] );
		}
		var img		= td.appendChild( document.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id + 2 ] );
		}
	}
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent , 			//!< [in] root dom
		x , 
		y
		)
{
//	alert( "x="+x+"y=" + y );
//	var	table = parent.appendChild( document.createElement( "table" ) );
	var	table	= document.createElement( "table" );
	{
		table.onmousedown		= new CallbackAdapt( m_Self.OnClick ).exec;
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
//		table.setAttribute( "width" , "100%" );
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );
	CreateDom_line( tbody , 0 , null );
	CreateDom_line( tbody , 3 , m_View );
	CreateDom_line( tbody , 6 , null );
	
//	parent.appendChild( table );
	parent.appendChild( m_Shadow.GenDOM( table ) );
}

// public functions define
//=======================================================================
//!	menuの開始
//!	@retval			---
//-----------------------------------------------------------------------
this.ShowMenu = function
		(
		x ,		//!< [in] 表示位置 
		y		//!< [in] 表示位置
		)
{
	//コールバックの登録
	this.HideMenu();
	RegistHideMenu( this.OnHideMenu );

	//すでにDOMがある場合
	{
		var		menu = document.getElementById( m_Id );
		if( menu != null )
		{
			var	parent = menu.parentNode;
			parent.removeChild( menu );
			menu.style.left		= x + "px";
			menu.style.top		= y + "px";
			menu.style.visibility="visible";
			parent.appendChild( menu );
			return;
		}
	}
	// DOMの作成
	var	menu	= document.createElement( "div" );
	{
		menu.setAttribute( "id" , m_Id );
		menu.style.position	= "absolute";
		menu.style.left		= x + "px";
		menu.style.top		= y + "px";
	}
	CreateDomUnderRoot( menu , x , y );
	
	// ルートに追加する
	document.body.appendChild( menu );
}
//=======================================================================
//!	menuの終了
//!	@retval			---
//-----------------------------------------------------------------------
this.HideMenu = function()
{
	UnregistHideMenu( this.OnHideMenu );
	
	var		menu = document.getElementById( m_Id );
	if( menu == null )
		return;
	if( menu.style.visibility == "hidden" )
		return;
	menu.style.visibility="hidden";
	
	if( m_Self.onhide != null )
		m_Self.onhide();
//	menu.parentNode.removeChild( menu );
}
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function()
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}

}
