﻿
//=======================================================================
//!	ユニークID生成
//!	@retval			---
//-----------------------------------------------------------------------
var		m_UniqueCount = 0;
function GetUniqueId()
{
	m_UniqueCount += 1;
	return m_UniqueCount;
}

/****************************************************************************
"Size" class 
****************************************************************************/
//コールバックイベント用アダプタ
/////////////////////////////////////////////////////////////////////////////
function Size
		(
		w , 
		h
		)
{
	this.m_Width	= w;
	this.m_Height	= h;
}


/****************************************************************************
"CallbackAdapt" class 
****************************************************************************/
//コールバックイベント用アダプタ
/////////////////////////////////////////////////////////////////////////////
function CallbackAdapt
		(
		func
		)
{
	var		m_Func 	= func;
	var		m_Args	= new Array( 0 );
	{
		var	i;
		for( i = 0 ; i < arguments.length - 1 ; i++ )
		{
			m_Args.push( arguments[ i + 1 ] );
		}
	}
	this.exec = function()
	{
		return m_Func( m_Args );
	}
}

//=======================================================================
//! すべての子供を削除する	
//!	@retval			---
//-----------------------------------------------------------------------
function RemoveChildAll
		(
		parent
		)
{
	if( parent == null )
		return;
	while( parent.firstChild != null )
	{
		parent.removeChild( parent.firstChild );
	}
}
//=======================================================================
//!	 cookieに保存する
//!	@retval			---
//-----------------------------------------------------------------------
function SetCookie
		( 
		name,
		value , 
		day 
		)
{
   date = new Date();
   date.setTime(date.getTime()+(day*24*60*60*1000));
   
   c_item = "@" + name + "=" + escape( value ) + ";";
   expires = "expires="+date.toGMTString();
   document.cookie = c_item + expires;
}
//=======================================================================
//!	cookieから獲得する
//!	@retval			---
//-----------------------------------------------------------------------
function GetCookie
		(
		name
		)
{
   name = "@" + name + "=";
   value = null;
   data = document.cookie + ";" ;
   offset = data.indexOf( name );
   if (offset != -1)
   {
      start = offset + name.length;
      end   = data.indexOf(";" , start);
      value = unescape( data.substring( start , end ) );
   }
   return value;
}
//=======================================================================
//!	rgbを文字列に変換する
//!	@retval			---
//-----------------------------------------------------------------------
function RgbToStr
		(
		r , 
		g , 
		b
		)
{
	rr = Number( r ).toString( 16 );
	if( rr.length == 1 )
		rr = "0" + rr; 

	gg = Number( g ).toString( 16 );
	if( gg.length == 1 )
		gg = "0" + gg; 

	bb = Number( b ).toString( 16 );
	if( bb.length == 1 )
		bb = "0" + bb; 
	
	return "#" + rr + gg + bb;
}
//=======================================================================
//!	色を文字列に変換する
//!	@retval			---
//-----------------------------------------------------------------------
function ColorToStr
		(
		color
		)
{
	return RgbToStr( Math.floor( color / 256 / 256 ) , Math.floor( color / 256 ) % 256 , color % 256 );
}
//=======================================================================
//!	エレメントの座標の獲得
//!	@retval			---
//-----------------------------------------------------------------------
function GetElementPos
		(
		doc , 
		elem
		)
{
	var offsetLeft = 0;
	var offsetTop = 0;

	while( elem != null )
	{
   		offsetLeft 	+= elem.offsetLeft;
   		offsetTop 	+= elem.offsetTop;
   		elem = elem.offsetParent;
  	}

	if( navigator.userAgent.indexOf( "Mac" ) != -1 
	&& typeof doc.body.leftMargin != "undefined")
	{
   		offsetLeft += doc.body.leftMargin;
   		offsetTop += doc.body.topMargin;
  	}
 	return{ x:offsetLeft , y:offsetTop }
}
//=======================================================================
//!	GetIFrameDocument
//!	@retval			---
//-----------------------------------------------------------------------
function GetIFrameDocument
		(
		iframe 
		)
{
	if( document.all )
		return iframe.contentWindow.document;
	else
		return iframe.contentDocument;
}
//=======================================================================
//!	ユニークな文字列を生成する
//!	@retval			---
//-----------------------------------------------------------------------
function GenUniqueString()
{
	var	d = new Date();
	var	s = 
	"" + d.getUTCMonth()
	+ "" + d.getUTCDate()
	+ "" + d.getUTCHours()
	+ "" + d.getUTCMinutes()
	+ "" + d.getUTCSeconds()
	+ "" + d.getUTCMilliseconds()
	+ "" + Math.floor( Math.random() * 10000 );
//	alert( s );
	return s;
}
