/****************************************************************************
"QueData" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function QueData()
{
	this.m_Cmd		= null;
	this.m_ParentId	= null;
	this.m_Offset	= null;
	this.m_Title	= null;
	this.m_Id		= null;
	this.m_Document	= null;
	this.m_Icon		= null;
	this.m_Handle	= null;
	this.m_Async	= true;
	this.m_Deleted	= false;
	
	// メンバ変数
	var		m_Self				= this;
	
// private function define

// public functions define
//=======================================================================
//!	dataの作成
//!	@retval			---
//-----------------------------------------------------------------------
this.GetData = function()
{
	if( m_Self.m_Cmd == "new" )
	{
		return "cmd=new"
			+ "&parentid=" + m_Self.m_ParentId 
			+ "&offset=" +m_Self. m_Offset 
			+ "&id=" + m_Self.m_Id 
			+ "&title=" + encodeURIComponent( m_Self.m_Title )
			+ "&document=" + encodeURIComponent( m_Self.m_Document )
			+ "&icon=" + m_Self.m_Icon 
			+ "&open=" + m_Self.m_Handle;
	}
	else if( m_Self.m_Cmd == "update" )
	{
		return "cmd=update"
			+ "&id=" + m_Self.m_Id
			+ ( ( m_Self.m_Title != null ) ? ( "&title=" + encodeURIComponent( m_Self.m_Title ) ) : "" )
			+ ( ( m_Self.m_Document != null ) ? ( "&document=" + encodeURIComponent( m_Self.m_Document ) ) : "" )
			+ ( ( m_Self.m_Icon != null ) ? ( "&icon=" + m_Self.m_Icon ) : "" )
			+ ( ( m_Self.m_Handle != null ) ? ( "&open=" + m_Self.m_Handle ) : "" );
	}
	else if( m_Self.m_Cmd == "delete" )
	{
		return "cmd=delete&id=" + m_Self.m_Id;
	}
	else if( m_Self.m_Cmd == "gettree" )
	{	
		return "cmd=gettree";
	}
	else if( m_Self.m_Cmd == "getdocument" )
	{
		return "cmd=getdocument&id=" + m_Self.m_Id;
	}
	else if( m_Self.m_Cmd == "move" )
	{
		return "cmd=move"
			+ "&id=" + m_Self.m_Id 
			+ "&parentid=" + m_Self.m_ParentId 
			+ "&offset=" +m_Self. m_Offset 
	}
}
}


/****************************************************************************
"Storage" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function Storage
		(
		php_path
		)
{
	// イベント
	this.onnew;
	this.onupdate;
	this.ondelete;
	this.ongettree;
	this.ongetdocument;
	this.onmove;
	this.onerror;
	
	// データ
	var		m_PhpPath			= php_path;
	var		m_Que				= new Array( 0 );
	var		m_ExecuteFlag		= false;
	
	// メンバ変数
	var		m_Self				= this;

// イベントハンドラ
//=======================================================================
//!	OnReceiveRequest
//!	@retval			---
//-----------------------------------------------------------------------
this.OnReceiveRequest = function
		(
		result
		)
{
	// アップデート
//	alert( result.responseText );

	//エラーチェック
	{
		var		error = result.responseXML.getElementsByTagName('error')
		if( error.length != 0 )
		{
			if( m_Self.onerror != null )
			{
				m_ExecuteFlag	= false;
				m_Self.onerror( m_Que[ 0 ] );
				
				//エラーでも次の命令を実行する
				m_Que.shift();
				m_Self.Execute();
				return;
			}
		}
	}	
	//shift
	var	que = m_Que[ 0 ];
	
	// event
	if( que.m_Cmd == "new" )
	{
		if( m_Self.onnew != null && que.m_Deleted == false )
			m_Self.onnew( que.m_Id );
	}
	else if( que.m_Cmd == "update" )
	{
		if( m_Self.onupdate != null && que.m_Deleted == false )
			m_Self.onupdate( que.m_Id );
	}
	else if( que.m_Cmd == "delete" )
	{
		RemoveId( que.m_Id );
		if( m_Self.ondelete != null )
			m_Self.ondelete( que.m_Id );
	}
	else if( que.m_Cmd == "gettree" )
	{
		if( m_Self.ongettree != null )
			m_Self.ongettree( AnalizeGetTree( result ) );
	}
	else if( que.m_Cmd == "getdocument" )
	{
		if( m_Self.ongetdocument != null && que.m_Deleted == false )
		{
			var	decode;
//			try
      		{
				decode = decodeURIComponent( result.responseText );
      		}
//      		catch(err)
//      		{
//				decode = result.responseText.substring( 0 , result.responseText.length - 1 ) + "0";
//				decode = decodeURIComponent( decode );
//     		} 
	  //			alert( result.responseText );
			m_Self.ongetdocument( que.m_Id , decode );//AnalizeGetDocument( result ) );
		}
	}
	else if( que.m_Cmd == "move" )
	{
		if( m_Self.onmove != null && que.m_Deleted == false )
			m_Self.onmove( que.m_Id );
	}
	m_ExecuteFlag	= false;
	m_Que.shift();
	
	//次のコマンドを実行する
	m_Self.Execute();
}	
// private function define
//=======================================================================
//!	GetTree
//!	@retval			---
//-----------------------------------------------------------------------
function GetTree
		(
		xml , 
		data
		)
{
	var		it = new Array( 5 );
	
	var		att_off , att_num = xml.attributes.length;
	for( att_off = 0 ; att_off < att_num ; att_off++ )
	{
		if( xml.attributes[ att_off ].nodeName == "title" )
			it[ 0 ]	= decodeURIComponent( xml.attributes[ att_off ].nodeValue );
		else if( xml.attributes[ att_off ].nodeName == "icon" )
			it[ 1 ]	= xml.attributes[ att_off ].nodeValue;
		else if( xml.attributes[ att_off ].nodeName == "open" )
			it[ 2 ]	= xml.attributes[ att_off ].nodeValue == 0 ? false : true;
		else if( xml.attributes[ att_off ].nodeName == "id" )
			it[ 3 ] = xml.attributes[ att_off ].nodeValue;
	}
	it[ 4 ]	= null;
	
	if( data[ 4 ] == null )
		data[ 4 ] = new Array();
	data[ 4 ].push( it );

	var		off , num = xml.childNodes.length;
	for( off = 0 ; off < num ; off++ )
	{
		if( xml.childNodes[ off ].tagName == "item" )
			GetTree( xml.childNodes[ off ] , it );
	}
}
//=======================================================================
//!	analize gettree
//!	@retval			---
//-----------------------------------------------------------------------
function AnalizeGetTree
		(
		result
		)
{
/*
<tree>
	<item title="??" id="??" icon="??" open="true/false">
		<item title="??" id="??" icon="??" open="true/false">
		</item>
		<item title="??" id="??" icon="??" open="true/false">
		</item>
	</item>
	...
</tree>
*/
	var		data = new Array( 5 );
	data[ 0 ]	= "root";
	data[ 1 ]	= 0;
	data[ 2 ]	= true;
	data[ 3 ] 	= "root";
	data[ 4 ]	= null;

	var		tree = result.responseXML.getElementsByTagName('tree')[ 0 ];
	var		off , num = tree.childNodes.length;
	for( off = 0 ; off < num ; off++ )
	{
		if( tree.childNodes[ off ].tagName == "item" )
			GetTree( tree.childNodes[ off ] , data );
	}
	return data;
}
//=======================================================================
//!	analize getdocument
//!	@retval			---
//-----------------------------------------------------------------------
function AnalizeGetDocument
		(
		result
		)
{
/*
<document>
	HTMLのドキュメント
</document>
*/
	var		docs = result.responseXML.getElementsByTagName('document');
	if( docs[ 0 ].firstChild == null )
		return "";
	
	return decodeURIComponent( docs[ 0 ].firstChild.nodeValue );

}
//=======================================================================
//!	remove id
//!	@retval			---
//-----------------------------------------------------------------------
function RemoveId
		(
		id
		)
{
	var		off , num = m_Que.length;
	for( off = 0 ; off < num ; off++ )
	{
		if( m_Que[ off ].m_Id == id )
			m_Que[ off ].m_Deleted = true;
	}
}
// public functions define
//=======================================================================
//!	execute command
//!	@retval			---
//-----------------------------------------------------------------------
this.Execute	= function()
{
	if( m_ExecuteFlag == true )
		return;
	if( m_Que.length == 0 )
		return;
		
	
	m_ExecuteFlag	= true;	
	requestFile( "POST" , encodeURI( m_Que[ 0 ].GetData() ) , m_PhpPath , this.OnReceiveRequest , m_Que[ 0 ].m_Async );
}
//=======================================================================
//!	Queが存在するか調べる
//!	@retval			---
//-----------------------------------------------------------------------
this.IsQueExist = function()
{
	var	len = m_Que.length;
	if( len == 0 )
		return false;
	
	this.Execute();
	return true;
}
//=======================================================================
//!	new
//!	@retval			---
//-----------------------------------------------------------------------
this.New = function
		(
		parentid , 
		offset , 
		id , 
		title , 
		doc , 
		icon , 
		handle , 
		async
		)
{	
	var		que = new QueData();
	que.m_Cmd		= "new";
	que.m_ParentId	= parentid;
	que.m_Offset	= offset;	
	que.m_Id		= id;
	que.m_Title		= title;
	que.m_Document	= doc;
	que.m_Icon		= icon;
	que.m_Handle	= handle == false ? 0 : 1;
	que.m_Async		= ( ( async == false ) && ( m_Self.IsQueExist() == false ) ) ? false : true;
	m_Que.push( que );
	this.Execute();
}
//=======================================================================
//!	update
//!	@retval			---
//-----------------------------------------------------------------------
this.Update = function
		(
		id , 
		title , 
		doc , 
		icon , 
		handle , 
		async
		)
{
	var		que = new QueData();
	que.m_Cmd		= "update";
	que.m_Id		= id;
	que.m_Title		= title == null ? title : title.substring( 0 , 256 );
	que.m_Document	= doc == null ? doc : doc.substring( 0 , 65536 );
	que.m_Icon		= icon;
	que.m_Handle	= handle == false ? 0 : 1;
	que.m_Async		= ( ( async == false ) && ( m_Self.IsQueExist() == false ) ) ? false : true;
	m_Que.push( que );
	this.Execute();
}
//=======================================================================
//!	delete
//!	@retval			---
//-----------------------------------------------------------------------
this.Delete = function
		(
		id , 
		async
		)
{
	var		que = new QueData();
	que.m_Cmd		= "delete";
	que.m_Id		= id;
	que.m_Async		= ( ( async == false ) && ( m_Self.IsQueExist() == false ) ) ? false : true;
	m_Que.push( que );
	this.Execute();
}
//=======================================================================
//!	gettree
//!	@retval			---
//-----------------------------------------------------------------------
this.GetTree = function
		(
		async
		)
{
	var		que = new QueData();
	que.m_Cmd		= "gettree";
	que.m_Async		= ( ( async == false ) && ( m_Self.IsQueExist() == false ) ) ? false : true;
	m_Que.push( que );
	this.Execute();
}
//=======================================================================
//!	getdocument
//!	@retval			---
//-----------------------------------------------------------------------
this.GetDocument = function
		(
		id , 
		async
		)
{
	var		que = new QueData();
	que.m_Cmd		= "getdocument";
	que.m_Id		= id;
	que.m_Async		= ( ( async == false ) && ( m_Self.IsQueExist() == false ) ) ? false : true;
	m_Que.push( que );
	this.Execute();
}
//=======================================================================
//!	move
//!	@retval			---
//-----------------------------------------------------------------------
this.Move = function
		(
		id , 
		parentid , 
		offset , 
		async
		)
{
	var		que = new QueData();
	que.m_Cmd		= "move";
	que.m_Id		= id;
	que.m_ParentId	= parentid;
	que.m_Offset	= offset;
	que.m_Async		= ( ( async == false ) && ( m_Self.IsQueExist() == false ) ) ? false : true;
	m_Que.push( que );
	this.Execute();
}
}
