﻿/****************************************************************************
"iFrameView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function iFrameView
		(
		view
		)
{
	// メンバ変数
	var		m_Self				= this;
	var		m_View				= view;
	var 	m_Id				= "iFrameView_" + GetUniqueId();
	var		m_Doc				= null;
	
// イベント関数
//=======================================================================
//!	mousedown
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMouseOver = function
		(
		args
		)
{
	if( m_Doc.all == null )
	{
		iframe = m_Doc.getElementById( m_Id );
		if( iframe != null && iframe.contentWindow != null )
		{
			iframe.contentWindow.addEventListener('mousedown',new CallbackAdapt( m_Self.OnMouseDown ).exec, true);
		}
	}
	else
	{
		iframe = m_Doc.getElementById( m_Id );
		GetIFrameDocument( iframe ).onmousedown = new CallbackAdapt( m_Self.OnMouseDown ).exec;
	}
}
//=======================================================================
//!	mousedown
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMouseDown = function
		(
		args
		)
{
	OnBodyClick_menuview();
}
//=======================================================================
//!	OnTimer
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUpdateView = function
		(
		argc
		)
{
	var		iframe = m_Doc.getElementById( m_Id );
	if( iframe == null )
	{
		setTimeout( new CallbackAdapt( m_Self.OnUpdateView ).exec , 500 );
		return;
	}
	var		doc = GetIFrameDocument( iframe );
	if( doc == null || doc.body == null || doc.body.appendChild == null || m_View == null || m_Doc == null || m_View.CreateDOM == null )
	{
		setTimeout( new CallbackAdapt( m_Self.OnUpdateView ).exec , 500 );
		return;
	}
	doc.body.appendChild( m_View.CreateDOM( doc ) );
}
// private function define

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	
	var	obj	= m_Doc.createElement( "iframe" );
	obj.setAttribute( "id" , m_Id );
	obj.setAttribute( "width" , "200" );
	obj.setAttribute( "height" , "100%" );
	obj.setAttribute( "border" , 0 );
	obj.setAttribute( "frameborder" , 0 );
	obj.onload	= new CallbackAdapt( m_Self.OnUpdateView ).exec;
	obj.onmouseover 	= new CallbackAdapt( m_Self.OnMouseOver ).exec;
	obj.src = "blank.htm";

	if( doc.all != null )
		setTimeout( new CallbackAdapt( m_Self.OnUpdateView ).exec , 500 );
		
	return obj;
}

}
