﻿/****************************************************************************
"IconSelectView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function IconSelectView
		(
		w_num , 
		icon_list , 
		icon_over_list
		)
{
	// イベント
	this.onover					= null;
	this.onclick				= null;
	
	// データ
	var		m_WidthNum			= w_num;
	var		m_Iconlist			= icon_list;
	var		m_IconOverlist		= icon_over_list;
	var		m_SelectX			= 0;
	var		m_SelectY			= 0;
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "IconSelectView_" + GetUniqueId();
	var		m_Doc				= null;
	
// イベント
/*==================================================
mouseenter
		return   ---
---------------------------------------------------*/
this.OnMouseOver = function
		(
		args
		)
{
	sx = args[ 0 ];
	sy = args[ 1 ];
	if( sx == m_SelectX && sy == m_SelectY )
		return;
	
	{	
		var		old_it = m_Doc.getElementById( m_Id + "index_" + m_SelectX + "_" + m_SelectY );
		var		it = m_Doc.getElementById( m_Id + "index_" + sx + "_" + sy );
		if( it == null )
			return;
		
		it.style.border	= "1px solid #000000";
		old_it.style.border	= "1px solid #FFFFFF";
	}
	{
		var		old_it = m_Doc.getElementById(  m_Id + "img_" + m_SelectX + "_" + m_SelectY );
		var		it = m_Doc.getElementById( m_Id + "img_" + sx + "_" + sy );
		old_it.setAttribute( "src" , m_Iconlist[ m_SelectX + m_SelectY * m_WidthNum ] );
		it.setAttribute( "src" , m_IconOverlist[ sx + sy * m_WidthNum ] );
	}
	
	//更新
	m_SelectX	= sx;
	m_SelectY	= sy;
	
	// イベント
	if( m_Self.onover != null )
		m_Self.onover();
}
/*==================================================
mouseenter
		return   ---
---------------------------------------------------*/
this.OnClick = function
		(
		args
		)
{
	// イベント
	if( m_Self.onclick != null )
		m_Self.onclick();
}
// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent			//!< [in] root dom
		)
{
	var	table	= parent.appendChild( m_Doc.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
//		table.setAttribute( "width" , 100 );
//		table.setAttribute( "height" , 100 );
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );

	for( var y = 0 ; y < m_Iconlist.length / m_WidthNum ; y++ )
	{
		var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
		
		for( var x = 0 ; x < m_WidthNum ; x++ )
		{
			var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
			{
				if( y * m_WidthNum + x < m_Iconlist.length )
				{
					var	tt	= td.appendChild( m_Doc.createElement( "table" ) );
					{
						tt.onmouseover 	= new CallbackAdapt( m_Self.OnMouseOver , x , y ).exec;
						tt.onmousedown 	= new CallbackAdapt( m_Self.OnClick , x , y ).exec;
						tt.setAttribute( "id" , m_Id + "index_" + x + "_" + y );
				
						if( x == m_SelectX && y == m_SelectY )
							tt.style.border	= "1px solid #000000";
						else
						{
							tt.style.border	= "1px solid #FFFFFF";
						}
					}
					var	ttbody	= tt.appendChild( m_Doc.createElement( "tbody" ) );
					var	ttr		= ttbody.appendChild( m_Doc.createElement( "tr" ) );
					var	ttd		= ttr.appendChild( m_Doc.createElement( "td" ) );
					{
						var		img = ttd.appendChild(m_Doc.createElement( "img" ) );
						{
							img.setAttribute( "id" , m_Id + "img_" + x + "_" + y );
							if( y == m_SelectY && x == m_SelectX )
								img.setAttribute( "src" , m_IconOverlist[ y * m_WidthNum + x ] );
							else
								img.setAttribute( "src" , m_Iconlist[ y * m_WidthNum + x ] );
						}
					}
				}
			}
		}
	}
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	選択の獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelect = function()
{
	return m_SelectY * m_WidthNum + m_SelectX;
}
}


/****************************************************************************
"IconSelectMenu" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function IconSelectMenu
		(
		lt_path , 
		ct_path , 
		rt_path , 
		lc_path , 
		cc_path , 
		rc_path , 
		lb_path , 
		cb_path , 
		rb_path , 
		sd_folder , 
		w_num , 
		iconlist , 
		icon_over_list
		)
{
// イベント
/*==================================================
mouseenter
		return   ---
---------------------------------------------------*/
this.OnSelect = function()
{
	m_Menu.HideMenu();
	if( m_Self.onselect != null )
		m_Self.onselect();
}
//=======================================================================
//!	hide
//!	@retval			---
//-----------------------------------------------------------------------
this.OnHide	 = function()
{
}
	// イベント
	this.onselect		= null;
	
	//ビュー
	var		m_IconSelect = new IconSelectView
			(
			w_num , 
			iconlist , 
			icon_over_list
			);
	m_IconSelect.onclick = this.OnSelect;
	var		m_Menu = new MenuView
			(
			lt_path , 
			ct_path , 
			rt_path , 
			lc_path , 
			cc_path , 
			rc_path , 
			lb_path , 
			cb_path , 
			rb_path , 
			sd_folder , 
			m_IconSelect
			);
	m_Menu.onhide	= this.OnHide;
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "IconSelectMenu_" + GetUniqueId();
	var		m_Doc				= null;
	
// private function define

// public functions define
//=======================================================================
//!	menuの開始
//!	@retval			---
//-----------------------------------------------------------------------
this.ShowMenu = function
		(
		x ,		//!< [in] 表示位置 
		y		//!< [in] 表示位置
		)
{
	m_Menu.ShowMenu( x , y );
}
//=======================================================================
//!	menuの終了
//!	@retval			---
//-----------------------------------------------------------------------
this.HideMenu = function()
{	
	m_Menu.HideMenu();
}
//=======================================================================
//!	選択の獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelect = function()
{
	return m_IconSelect.GetSelect();
}
}
/****************************************************************************
"IconSelectButton" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function IconSelectButton
		(
		lt_path , 
		ct_path , 
		rt_path , 
		lc_path , 
		cc_path , 
		rc_path , 
		lb_path , 
		cb_path , 
		rb_path , 
		sd_folder , 
		w_num , 
		iconlist , 
		iconoverlist		
		)
{
//=======================================================================
//!	mousedown
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMouseUp = function
		(
		args
		)
{
	var		button = document.getElementById( m_Id );
	if( button == null )
		return;
		
	pos = GetElementPos( m_Doc , button );
	m_SelectMenu.ShowMenu( pos.x , pos.y + button.offsetHeight );	
}
//=======================================================================
//! select	
//!	@retval			---
//-----------------------------------------------------------------------
this.OnSelect = function()
{
	m_Self.SetSelect( m_SelectMenu.GetSelect() );
	if( m_Self.onselect != null )
		m_Self.onselect();
}
	// イベント
	this.onselect				= null;
	
	// views
	var		m_SelectMenu		= new IconSelectMenu
			(
			lt_path , 
			ct_path , 
			rt_path , 
			lc_path , 
			cc_path , 
			rc_path , 
			lb_path , 
			cb_path , 
			rb_path , 
			sd_folder , 
			w_num , 
			iconlist , 
			iconoverlist
			);
	m_SelectMenu.onselect	= this.OnSelect;
	
	// データ
	var		m_Iconlist	= iconlist;
	var		m_Select	= 0;
	 
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "IconSelectButton_" + GetUniqueId();
	var		m_Doc				= null;
	
// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent			//!< [in] root dom
		)
{
	var		img = parent.appendChild(m_Doc.createElement( "img" ) );
	{
		img.setAttribute( "src" , m_Iconlist[ m_Select ] );
		img.style.cursor='pointer';
		img.onmouseup 	= new CallbackAdapt( m_Self.OnMouseUp ).exec;
	}
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	選択の設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetSelect = function
		(
		sel
		)
{
	m_Select	= sel;
	
	if( m_Doc == null )
		return;
	var		obj = m_Doc.getElementById( m_Id );
	if( obj == null )
		return;
	RemoveChildAll( obj );
	CreateDomUnderRoot( obj );
}
//=======================================================================
//!	選択の獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.GetSelect = function()
{
	return m_Select;
}
}

