/****************************************************************************
"OverView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function OverView
		(
		lt_path , 
		ct_path , 
		rt_path , 
		lc_path , 
		cc_path , 
		rc_path , 
		lb_path , 
		cb_path , 
		rb_path 
		)
{
	var		m_ImgPath 			= Array
			( 
			lt_path , 
			ct_path , 
			rt_path , 
			lc_path , 
			cc_path , 
			rc_path , 
			lb_path , 
			cb_path , 
			rb_path 
			);	
	var		m_Callback			= null;
	var		m_Message			= "";
	var		m_Show				= true;
	
	// event object
	var		m_ResizeEvent		= null;
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "OverView_" + GetUniqueId();
	var		m_Doc				= null;
	
// イベント関数

// private function define
//=======================================================================
//!	hide back
//!	@retval			---
//-----------------------------------------------------------------------
function HideBack
		(
		parent
		)
{
	var	div	= parent.appendChild( m_Doc.createElement( "div" ) );
	{
		div.setAttribute( "id" , m_Id );
//		div.style.position	= "absolute";
		div.style.left		= 0;
		div.style.top		= 0;
//		div.setAttribute( "width" , "100" );
//		div.setAttribute( "height" , "100" );
		div.style.width		= "100";//m_Doc.body.clientWidth;//"100%";
		div.style.height	= "100";//m_Doc.body.clientHeight;//"100%";
		div.style.backgroundColor	= "#333333";
		if( div.style.opacity != null )
			div.style.opacity	= "0.2";
		else
			div.style.filter = 'alpha(opacity=20)';
	}
	return div;
}
//=======================================================================
//!	show dialgo frame
//!	@retval			---
//-----------------------------------------------------------------------
function GetDialgCenter
		(
		parent
		)
{
	var		obj;
	var	div	= parent.appendChild( m_Doc.createElement( "div" ) );
	{
		div.setAttribute( "id" , m_Id + "_Dialog" );
		div.style.position	= "absolute";
		div.style.left		= 0;
		div.style.top		= 0;
		div.style.width		= "100%";
		div.style.height		= "100%";
	}
	var	table	= div.appendChild( m_Doc.createElement( "table" ) );
	{
		table.setAttribute( "width" , "100%" );
		table.setAttribute( "height" , "100%" );
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );

	for( y = 0 ; y < 3 ; y++ )
	{
		var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
		for( x = 0 ; x < 3 ; x++ )
		{
			var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
			if( x == 1 && y == 1 )
			{
				td.setAttribute( "align" , "center" );
				obj = td;
			}
		}
	}
	return obj;
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDom_line
		(
		tbody , 			//!< [in] parent dom
		image_id , 
		content
		)
{
/*
<table cellspacing="0" cellpadding="0" width="100%" border="0">
<tbody>
  <tr>
    <td width="1" background="../img/open_0_0.png" ><img src="../img/open_0_0.png"></td>
    <td background="../img/open_0_1.png">content または <img src="../img/open_0_1.png"></td>
    <td width="1" background="../img/open_0_2.png"><img src="../img/open_0_2.png"></td>
  </tr>
</tbody>  
</table>
*/
/*
	var	table	= parent.appendChild( m_Doc.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
//		table.setAttribute( "width" , "100%" );
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
*/
	var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
	{
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id ] );
		}
		var img		= td.appendChild( m_Doc.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id ] );
		}
	}
	{
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "background" , m_ImgPath[ image_id + 1 ] );
		}
		if( content != null && content.CreateDOM != null )
			td.appendChild( content.CreateDOM( m_Doc ) );
		else
		{
			var img		= td.appendChild( m_Doc.createElement( "img" ) );
			{
				img.setAttribute( "src" , m_ImgPath[ image_id + 1 ] );
			}
		}			
	}
	{
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id + 2 ] );
		}
		var img		= td.appendChild( m_Doc.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id + 2 ] );
		}
	}
}
//=======================================================================
//!	show dialgo frame
//!	@retval			---
//-----------------------------------------------------------------------
function DialogFrame
		(
		parent
		)
{
	var	table	= m_Doc.createElement( "table" );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
//		table.setAttribute( "width" , "100%" );
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
	CreateDom_line( tbody , 0 , null );
	CreateDom_line( tbody , 3 , new HtmlView( m_Message ) );
	CreateDom_line( tbody , 6 , null );
	
	parent.appendChild( table );
}
//=======================================================================
//!	ShowDom
//!	@retval			---
//-----------------------------------------------------------------------
function ShowDom
		(
		parent
		)
{
	var		back_div = HideBack( parent );
	if( m_Message != "" )
	{		
		var		center	= GetDialgCenter( parent );
		DialogFrame( center );
	}
}
//=======================================================================
//!	show dialog
//!	@retval			---
//-----------------------------------------------------------------------
function ShowDialog()
{
	var	bb = getElementById( m_Id + "_base" );
	if( bb == null )
		return;
	ShowDom( bb );
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id + "_base" );

	if( m_Show == true )
		ShowDom( root );
	return root;
}

//=======================================================================
//!	表示する
//!	@retval			---
//-----------------------------------------------------------------------
this.Show = function
		(
		msg
		)
{
	m_Message	= msg;
	m_Show		= true;
	ShowDialog();
}
//=======================================================================
//!	hide dialog
//!	@retval			---
//-----------------------------------------------------------------------
this.Hide = function()
{
	m_Show	= false;
	{
	var		dlg = m_Doc.getElementById( m_Id + "_Dialog" );
	if( dlg == null )
		return;
	dlg.parentNode.removeChild( dlg );
	}
	{
	var		dlg = m_Doc.getElementById( m_Id );
	if( dlg == null )
		return;
	dlg.parentNode.removeChild( dlg );
	}
}

}
