﻿/****************************************************************************
"PanelView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function PanelView
		(
		open_lt_path , 
		open_ct_path , 
		open_rt_path , 
		open_lc_path , 
		open_cc_path , 
		open_rc_path , 
		open_lb_path , 
		open_cb_path , 
		open_rb_path , 
		view
		)
{
	var		m_Images			= new Array
			(
			open_lt_path ,  
			open_ct_path ,  
			open_rt_path ,  
			open_lc_path ,  
			open_cc_path ,  
			open_rc_path ,  
			open_lb_path ,  
			open_cb_path , 
			open_rb_path
			);

	// メンバ変数
	var		m_View				= view;
	var		m_Self				= this;
	var 	m_Id				= "PanelView_" + GetUniqueId();

// private function define
//=======================================================================
//!	edgeの作成
//!	@retval			---
//-----------------------------------------------------------------------
function CreateEdge
		(
		tr , 
		img_id
		)
{
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1px" );
			td.setAttribute( "height" , "1px" );
			var	img = td.appendChild( document.createElement( "img" ) );
			{
				img.setAttribute( "src" , m_Images[ img_id ] );
			}
		}
	}
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "100%" );
			td.setAttribute( "background" , m_Images[ img_id + 1 ] );
		}
	}
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1px" );
			var	img = td.appendChild( document.createElement( "img" ) );
			{
				img.setAttribute( "src" , m_Images[ img_id + 2 ] );
			}
		}
	}
}
//=======================================================================
//!	edgeの作成
//!	@retval			---
//-----------------------------------------------------------------------
function CreateCenter
		(
		tr , 
		view_dom
		)
{
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "height" , "100%" );
			td.setAttribute( "background" , m_Images[ 3 ] );
		}
	}
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		td.setAttribute( "background" , m_Images[ 4 ] );
		{
			if( view_dom != null )
				td.appendChild( view_dom );
		}
	}
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "height" , "100%" );
			td.setAttribute( "background" , m_Images[ 5 ] );
		}
	}
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent , 			//!< [in] root dom
		view_dom
		)
{
	var	table	= parent.appendChild( document.createElement( "table" ) );
	{
		table.setAttribute( "width" , "100%" );
		table.setAttribute( "height" , "100%" );
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );
	{
		{
			var	tr 		= tbody.appendChild( document.createElement( "tr" ) );
			CreateEdge( tr , 0 );
		}
		{
			var	tr 		= tbody.appendChild( document.createElement( "tr" ) );
			CreateCenter( tr , view_dom );
		}
		{
			var	tr 		= tbody.appendChild( document.createElement( "tr" ) );
			CreateEdge( tr , 6 );
		}
	}
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function()
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	if( m_View != null && m_View.CreateDOM != null )
		CreateDomUnderRoot( root , m_View.CreateDOM() );
	else
		CreateDomUnderRoot( root , null );
	
	return root;
}
//=======================================================================
//!	GenDOM
//!	@retval			---
//-----------------------------------------------------------------------
this.GenDOM = function
		(
		view_dom
		)
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root , view_dom );
	
	return root;

}

}
