﻿/****************************************************************************
"ShadowView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ShadowView
		(
		img_folder , 
		view
		)
{
	var		m_Images			= new Array
			(
			img_folder + "/sd_0_0.png" ,  
			img_folder + "/sd_0_1.png" ,  
			img_folder + "/sd_0_2.png" ,  
			img_folder + "/sd_1_0.png" ,  
			img_folder + "/sd_1_2.png" ,  
			img_folder + "/sd_2_0.png" ,  
			img_folder + "/sd_2_1.png" ,  
			img_folder + "/sd_2_2.png"
			);

	// メンバ変数
	var		m_View				= view;
	var		m_Self				= this;
	var 	m_Id				= "ShadowView_" + GetUniqueId();

// private function define
//=======================================================================
//!	edgeの作成
//!	@retval			---
//-----------------------------------------------------------------------
function CreateEdge
		(
		tr , 
		img_id
		)
{
/*
	<tr>
    	<td width="1" height="1"><img src="shadow/sd_0_0.png"></td>
    	<td>
			<table cellspacing="0" cellpadding="0" width="100%" height="100%" border="0"><tbody>
      			<tr>
        			<td width="1"><img src="shadow/sd_0_1.png"></td>
        			<td background="shadow/sd_0_2.png"><img width="1" height="1"></td>
        			<td width="1"><img src="shadow/sd_0_3.png"></td>
      			</tr>
    		</tbody></table>
		</td>
	   	<td width="1"><img src="shadow/sd_0_4.png"></td>
  	</tr>
*/
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1px" );
			td.setAttribute( "height" , "1px" );
			var	img = td.appendChild( document.createElement( "img" ) );
			{
				img.setAttribute( "src" , m_Images[ img_id ] );
			}
		}
	}
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "100%" );
			td.setAttribute( "background" , m_Images[ img_id + 1 ] );
//			var	img = td.appendChild( document.createElement( "img" ) );
//			{
//				img.setAttribute( "src" , m_Images[ img_id + 1 ] );
//			}
		}
	}
/*	
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			var	table	= td.appendChild( document.createElement( "table" ) );
			{
				table.border 		= 0; 
				table.cellSpacing 	= 0; 
				table.cellPadding 	= 0;
				table.setAttribute( "width" , "100%" );
				table.setAttribute( "height" , "100%" );
				var tbody = table.appendChild( document.createElement( "tbody" ) );
				{
					var ttr = tbody.appendChild( document.createElement( "tr" ) );
					{
						var ttd = ttr.appendChild( document.createElement( "td" ) );
						{
							ttd.setAttribute( "width" , "1" );
							var	img = ttd.appendChild( document.createElement( "img" ) );
							{
								img.setAttribute( "src" , m_Images[ img_id + 1 ] );
							}
						}
						ttd = ttr.appendChild( document.createElement( "td" ) );
						{
							ttd.setAttribute( "background" , m_Images[ img_id + 2 ] );
							ttd.setAttribute( "width" , "100%" );
							var	img = ttd.appendChild( document.createElement( "img" ) );
							{
//								img.setAttribute( "src" , m_Images[ img_id + 2 ] );
								img.setAttribute( "width" , "1" );
								img.setAttribute( "height" , "1" );
							}
						}
						ttd = ttr.appendChild( document.createElement( "td" ) );
						{
							ttd.setAttribute( "width" , "1" );
							var	img = ttd.appendChild( document.createElement( "img" ) );
							{
								img.setAttribute( "src" , m_Images[ img_id + 3 ] );
							}
						}
					}
				}
			}
		}
	}
*/
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1px" );
			var	img = td.appendChild( document.createElement( "img" ) );
			{
				img.setAttribute( "src" , m_Images[ img_id + 2 ] );
			}
		}
	}
}
//=======================================================================
//!	edgeの作成
//!	@retval			---
//-----------------------------------------------------------------------
function CreateCenterEdge
		(
		td , 
		img_0 , 
		img_1 , 
		img_2
		)
{
//		td.setAttribute( "background" , img_1 );
//		td.setAttribute( "height" , "100%" );

/*
			<table cellspacing="0" cellpadding="0" height="100%" border="0"><tbody>
      			<tr>
        			<td height="1"><img src="shadow/sd_1_0.png"></td>
      			</tr>
     	 		<tr>
      	 	 		<td background="shadow/sd_2_0.png"><img width="1" height="1"></td>
     	 		</tr>
     	 		<tr>
     	  	 		<td height="1"><img src="shadow/sd_3_0.png"></td>
     	 		</tr>
    		</tbody></table>
*/
	var	table	= td.appendChild( document.createElement( "table" ) );
	{
		table.border 		= 1; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
		table.setAttribute( "width" , "100%" );
		table.setAttribute( "height" , "100%" );
		table.style.backgroundColor = "#00FF00";
		var	tbody = table.appendChild( document.createElement( "tbody" ) );
		{
			var		ttr = tbody.appendChild( document.createElement( "tr" ) );
			{
				var		ttd = ttr.appendChild( document.createElement( "td" ) );
				{
					ttd.setAttribute( "height" , "1" );
					var		img = ttd.appendChild( document.createElement( "img" ) );
					{
						img.setAttribute( "src" , img_0 );
					}
				}
			}
			ttr = tbody.appendChild( document.createElement( "tr" ) );
			{
				var		ttd = ttr.appendChild( document.createElement( "td" ) );
				{
					ttd.setAttribute( "background" , img_1 );
//					ttd.setAttribute( "width" , "100%" );
					ttd.setAttribute( "height" , "100%" );

//					var		img = ttd.appendChild( document.createElement( "img" ) );
//					{
//						img.setAttribute( "src" , img_1 );
	//					img.setAttribute( "width" , "1" );
	//					img.setAttribute( "height" , "1" );
		//			}
				}
			}
			ttr = tbody.appendChild( document.createElement( "tr" ) );
			{
				var		ttd = ttr.appendChild( document.createElement( "td" ) );
				{
					ttd.setAttribute( "height" , "1" );
					var		img = ttd.appendChild( document.createElement( "img" ) );
					{
						img.setAttribute( "src" , img_2 );
					}
				}
			}
		}
	}
}
//=======================================================================
//!	edgeの作成
//!	@retval			---
//-----------------------------------------------------------------------
function CreateCenter
		(
		tr , 
		view_dom
		)
{
/*
    	<td>
			<table cellspacing="0" cellpadding="0" height="100%" border="0">
      			<tr>
        			<td height="1"><img src="shadow/sd_1_0.png"></td>
      			</tr>
     	 		<tr>
      	 	 		<td background="shadow/sd_2_0.png"><img width="1" height="1"></td>
     	 		</tr>
     	 		<tr>
     	  	 		<td height="1"><img src="shadow/sd_3_0.png"></td>
     	 		</tr>
    		</table>
		</td>
    	<td>aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa<br>aaaaaaa<br>aaaaaaa<br>aaaaaaa<br>aaaaaaa<br>aaaaaaa<br>aaaaaaa</td>
    	<td>
			<table cellspacing="0" cellpadding="0" height="100%" border="0"><tbody>
      			<tr>
        			<td height="1"><img src="shadow/sd_1_4.png"></td>
      			</tr>
      			<tr>
        			<td background="shadow/sd_2_4.png"><img width="1" height="1"></td>
      			</tr>
      			<tr>
        			<td height="1"><img src="shadow/sd_3_4.png"></td>
      			</tr>
    		</tbody></table>
		</td>
*/
///	{
		var	td1	= tr.appendChild( document.createElement( "td" ) );
//		var	div = td1.appendChild( document.createElement( "div" ) );
//		div.setAttribute( "height" , "100%" );
		td1.setAttribute( "height" , "100%" );
		CreateCenterEdge( td1 , m_Images[5] , m_Images[7] , m_Images[9] );
//	}
//	{
		var	td3	= tr.appendChild( document.createElement( "td" ) );
		{
			if( view_dom != null )
			{
//				td.appendChild( document.createTextNode( "aaaaaa\naaaaaa" ) );
				td3.appendChild( view_dom );
			}
		}
//	}
//	{
		var	td2	= tr.appendChild( document.createElement( "td" ) );
		td2.setAttribute( "height" , view_dom.offsetHeight );
		CreateCenterEdge( td2 , m_Images[6] , m_Images[8] , m_Images[10] );
//	}
}
//=======================================================================
//!	edgeの作成
//!	@retval			---
//-----------------------------------------------------------------------
function CreateCenter2
		(
		tr , 
		view_dom
		)
{
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "height" , "100%" );
			td.setAttribute( "background" , m_Images[ 3 ] );
//			var	img = td.appendChild( document.createElement( "img" ) );
//			{
//				img.setAttribute( "src" , m_Images[ img_id ] );
//			}
		}
	}
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			if( view_dom != null )
				td.appendChild( view_dom );
		}
	}
	{
		var	td	= tr.appendChild( document.createElement( "td" ) );
		{
			td.setAttribute( "height" , "100%" );
			td.setAttribute( "background" , m_Images[ 4 ] );
//			var	img = td.appendChild( document.createElement( "img" ) );
//			{
//				img.setAttribute( "src" , m_Images[ img_id + 2 ] );
//			}
		}
	}
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent , 			//!< [in] root dom
		view_dom
		)
{
/*
<table cellspacing="0" cellpadding="0" width="100" height="100" border="0">
<tbody>
	<tr>
    	<td width="1" height="1"><img src="shadow/sd_0_0.png"></td>
    	<td>
			<table cellspacing="0" cellpadding="0" width="100%" height="100%" border="0"><tbody>
      			<tr>
        			<td width="1"><img src="shadow/sd_0_1.png"></td>
        			<td background="shadow/sd_0_2.png"><img width="1" height="1"></td>
        			<td width="1"><img src="shadow/sd_0_3.png"></td>
      			</tr>
    		</tbody></table>
		</td>
	   	<td width="1"><img src="shadow/sd_0_4.png"></td>
  	</tr>
  	<tr>
    	<td>
			<table cellspacing="0" cellpadding="0" height="100%" border="0">
      			<tr>
        			<td height="1"><img src="shadow/sd_1_0.png"></td>
      			</tr>
     	 		<tr>
      	 	 		<td background="shadow/sd_2_0.png"><img width="1" height="1"></td>
     	 		</tr>
     	 		<tr>
     	  	 		<td height="1"><img src="shadow/sd_3_0.png"></td>
     	 		</tr>
    		</table>
		</td>
    	<td>aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa<br>aaaaaaa<br>aaaaaaa<br>aaaaaaa<br>aaaaaaa<br>aaaaaaa<br>aaaaaaa</td>
    	<td>
			<table cellspacing="0" cellpadding="0" height="100%" border="0"><tbody>
      			<tr>
        			<td height="1"><img src="shadow/sd_1_4.png"></td>
      			</tr>
      			<tr>
        			<td background="shadow/sd_2_4.png"><img width="1" height="1"></td>
      			</tr>
      			<tr>
        			<td height="1"><img src="shadow/sd_3_4.png"></td>
      			</tr>
    		</tbody></table>
		</td>
  	</tr>
  	<tr>
   		<td width="1" height="1"><img src="shadow/sd_4_0.png"></td>
   		<td>
			<table cellspacing="0" cellpadding="0" width="100%" height="100%" border="0"><tbody>
    			<tr>
       				<td width="1"><img src="shadow/sd_4_1.png"></td>
       				<td background="shadow/sd_4_2.png"><img width="1" height="1"></td>
       				<td width="1"><img src="shadow/sd_4_3.png"></td>
    			</tr>
    		</tbody></table>
		</td>
    	<td><img src="shadow/sd_4_4.png"></td>
  	</tr>
</tbody>
</table>
*/
	var	table	= parent.appendChild( document.createElement( "table" ) );
	{
		table.setAttribute( "width" , "10" );
		table.setAttribute( "height" , "100" );
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
	}
	var	tbody	= table.appendChild( document.createElement( "tbody" ) );
	{
		{
			var	tr 		= tbody.appendChild( document.createElement( "tr" ) );
			CreateEdge( tr , 0 );
		}
		{
			var	tr 		= tbody.appendChild( document.createElement( "tr" ) );
			CreateCenter2( tr , view_dom );
		}
		{
			var	tr 		= tbody.appendChild( document.createElement( "tr" ) );
			CreateEdge( tr , 5 );
		}
	}
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function()
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	if( m_View != null && m_View.CreateDOM != null )
		CreateDomUnderRoot( root , m_View.CreateDOM() );
	else
		CreateDomUnderRoot( root , null );
	
	return root;
}
//=======================================================================
//!	GenDOM
//!	@retval			---
//-----------------------------------------------------------------------
this.GenDOM = function
		(
		view_dom
		)
{
	var	root	= document.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root , view_dom );
	
	return root;

}

}
