﻿/****************************************************************************
"ToolbarView" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ToolbarView
		(
		lt_path , 
		ct_path , 
		rt_path , 
		lc_path , 
		cc_path , 
		rc_path , 
		lb_path , 
		cb_path , 
		rb_path
		)
{
	var		m_ImgPath 			= Array
			( 
			lt_path , 
			ct_path , 
			rt_path , 
			lc_path , 
			cc_path , 
			rc_path , 
			lb_path , 
			cb_path , 
			rb_path 
			);	
	var		m_Contents			= new Array( 0 );
	
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "ToolbarView_" + GetUniqueId();
	var		m_Doc				= null;
	
// private function define
//=======================================================================
//!	add contents
//!	@retval			---
//-----------------------------------------------------------------------
function AddContents
		(
		parent , 
		contents
		)
{
	var	table	= parent.appendChild( m_Doc.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
	var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
	
	var		off , num = contents.length;
	for( off = 0 ; off < num ; off++ )
	{
		if( contents[ off ].CreateDOM != null )
		{
			var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
			{
				td.setAttribute( "width" , "1" );
			}
			td.appendChild( contents[ off ].CreateDOM( m_Doc ) );
		}
	}

}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDom_line
		(
		root , 			//!< [in] root dom
		image_id , 
		contents
		)
{
/*
<table cellspacing="0" cellpadding="0" width="100%" border="0">
<tbody>
  <tr>
    <td width="1" background="../img/open_0_0.png" ><img src="../img/open_0_0.png"></td>
    <td background="../img/open_0_1.png">content または <img src="../img/open_0_1.png"></td>
    <td width="1" background="../img/open_0_2.png"><img src="../img/open_0_2.png"></td>
  </tr>
</tbody>  
</table>
*/
	var	table	= root.appendChild( m_Doc.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
		table.setAttribute( "width" , "100%" );
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );

	var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
	{
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id ] );
		}
		var img		= td.appendChild( m_Doc.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id ] );
		}
	}
	{
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "background" , m_ImgPath[ image_id + 1 ] );
		}
		if( contents != null && contents.length != 0 )
		{
			AddContents( td , contents );
		}
		else
		{
			var img		= td.appendChild( m_Doc.createElement( "img" ) );
			{
				img.setAttribute( "src" , m_ImgPath[ image_id + 1 ] );
			}
		}			
	}
	{
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "width" , "1" );
			td.setAttribute( "background" , m_ImgPath[ image_id + 2 ] );
		}
		var img		= td.appendChild( m_Doc.createElement( "img" ) );
		{
			img.setAttribute( "src" , m_ImgPath[ image_id + 2 ] );
		}
	}
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		root			//!< [in] root dom
		)
{
	CreateDom_line( root , 0 , null );
	CreateDom_line( root , 3 , m_Contents );
	CreateDom_line( root , 6 , null );
}

// public functions define
//=======================================================================
//!	viewの追加
//!	@retval			---
//-----------------------------------------------------------------------
this.AddView = function
		(
		view
		)
{
	m_Contents.push( view );
}
//=======================================================================
//!	viewsの追加
//!	@retval			---
//-----------------------------------------------------------------------
this.AddViews = function
		(
		views			//!< [in] viewの配列
		)
{
	var		off , num = views.length;
	for( off = 0 ; off < num ; off++ )
		m_Contents.push( views[ off ] );
}
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc		= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}

}
