﻿/****************************************************************************
"AboutDlg" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function AboutDlg
		(
		about_folder , 
		msgbox_folder , 
		sd_folder 
		)
{
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnYes		= function()
{
	m_Dialog.EndDialog();
}
	var		m_Dialog	= new DialogView
			(
			msgbox_folder + "/dlg_0_0.png" , 
			msgbox_folder + "/dlg_0_1.png" , 
			msgbox_folder + "/dlg_0_2.png" , 
			msgbox_folder + "/dlg_1_0.png" , 
			msgbox_folder + "/dlg_1_1.png" , 
			msgbox_folder + "/dlg_1_2.png" , 
			msgbox_folder + "/dlg_2_0.png" , 
			msgbox_folder + "/dlg_2_1.png" , 
			msgbox_folder + "/dlg_2_2.png" , 
			sd_folder
			);
	var		m_Yes		= new ButtonView
			(
			msgbox_folder + "/yes_0.png" , 
			msgbox_folder + "/yes_1.png" , 
			msgbox_folder + "/yes_2.png" , 
			null , 
			this.OnYes , 
			"push"
			);		


	// メンバ変数
	var		m_AboutFolder		= about_folder;
	var		m_Self				= this;
	var 	m_Id				= "AboutDlg_" + GetUniqueId();
	var		m_Doc				= null;
	
// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent			//!< [in] root dom
		)
{
	var	div	= parent.appendChild( m_Doc.createElement( "div" ) );
	div.setAttribute( "align" , "center" );
	div.appendChild( m_Doc.createElement("br") );

	{
		var	a = div.appendChild( m_Doc.createElement( "a" ) );
		a.setAttribute( "href" , "http://18.real-sound.net/~fanzo/" );
		a.setAttribute( "target" , "_blank" );
		var	img = a.appendChild( m_Doc.createElement( "img" ) );
		img.setAttribute( "src" , m_AboutFolder + "/Fanzo.png" );
	}
	div.appendChild( m_Doc.createElement("br") );
	{
		var	a = div.appendChild( m_Doc.createElement( "a" ) );
		a.setAttribute( "href" , "http://18.real-sound.net/~fanzo/" );
		a.setAttribute( "target" , "_blank" );
		var	font = a.appendChild( m_Doc.createElement( "font" ) );
		font.setAttribute( "size" , "-1" );
		font.appendChild( m_Doc.createTextNode( "http://18.real-sound.net/~fanzo/" ) );
	}
	div.appendChild( m_Doc.createElement("br") );
	{
		div.style.whiteSpace = "nowrap";
//		var	font = div.appendChild( m_Doc.createElement( "font" ) );
//		font.setAttribute( "size" , "-1" );
		div.appendChild( m_Doc.createTextNode( "Copylight(C) 2007 Fanzo. Allright Reserved" ) );
	}

	// fam fam fam
	div.appendChild( m_Doc.createElement("br") );
	div.appendChild( m_Doc.createElement("br") );
	{
		var	a = div.appendChild( m_Doc.createElement( "a" ) );
		a.setAttribute( "href" , "http://www.famfamfam.com/lab/icons/silk/ " );
		a.setAttribute( "target" , "_blank" );
		var	img = a.appendChild( m_Doc.createElement( "img" ) );
		img.setAttribute( "src" , m_AboutFolder + "/famfamfam.png" );
	}
	div.appendChild( m_Doc.createElement("br") );
	{
		var	a = div.appendChild( m_Doc.createElement( "a" ) );
		a.setAttribute( "href" , "http://www.famfamfam.com/lab/icons/silk/ " );
		a.setAttribute( "target" , "_blank" );
		var	font = a.appendChild( m_Doc.createElement( "font" ) );
		font.setAttribute( "size" , "-1" );
		font.appendChild( m_Doc.createTextNode( "http://www.famfamfam.com/lab/icons/silk/" ) );
	}
/*	
	{
		var	table	= div.appendChild( m_Doc.createElement( "table" ) );
		{
			table.border	= 1;
					
			var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
			{
				var	tr 		= tbody.appendChild( m_Doc.createElement( "tr" ) );
				{
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						{
							var	a = td.appendChild( m_Doc.createElement( "a" ) );
							a.setAttribute( "href" , "http://18.real-sound.net/~fanzo/" );
							a.setAttribute( "target" , "_blank" );
							var	img = a.appendChild( m_Doc.createElement( "img" ) );
							img.setAttribute( "src" , m_AboutFolder + "/Fanzo.png" );
						}
					}
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						{
							td.style.padding = "5px";
							var	ddiv	= td.appendChild( m_Doc.createElement( "div" ) );
							ddiv.style.whiteSpace = "nowrap";
							ddiv.appendChild( m_Doc.createTextNode( "Copylight(C) 2007 Fanzo. Allright Reserved" ) );
						}
					}
				}
				var	tr 		= tbody.appendChild( m_Doc.createElement( "tr" ) );
				{
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						{
							td.style.padding = "5px";
							var	ddiv	= td.appendChild( m_Doc.createElement( "div" ) );
							ddiv.style.whiteSpace = "nowrap";
							ddiv.appendChild( m_Doc.createTextNode( "タイトル名" ) );
						}
					}
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						{
						}
					}
				}
			}
		}
	}
*/
	div.appendChild( m_Doc.createElement("br") );
	div.appendChild( m_Doc.createElement("br") );
	// buttons
	{
		var	table	= div.appendChild( m_Doc.createElement( "table" ) );
		{
			table.border	= 0;
					
			var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
			{
				var	tr 		= tbody.appendChild( m_Doc.createElement( "tr" ) );
				{
					// yes
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						td.appendChild( m_Yes.CreateDOM( m_Doc ) );
					}
				}
			}
		}
	}
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	MessageDlg
//!	@retval			---
//-----------------------------------------------------------------------
this.Dialog = function()
{
	m_Dialog.SetView( m_Self );
	m_Dialog.SetTitleView( new HtmlView( '<font color="#FFFFFF" >WebNoteについて</font>' ) );
	m_Dialog.Dialog();
}
}


/****************************************************************************
"ContentEditDlg" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function ContentEditDlg
		(
		msgbox_folder , 
		menu_folder , 
		sd_folder , 
		icon_folder
		)
{
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnYes		= function()
{
	var	text = m_Doc.getElementById( m_Id + "_textfield" );
	if( text != null )
		m_ContentName = text.value;
	m_IconId	= m_Icons.GetSelect();
	
	if( m_ContentName.length != 0 )
	{
		m_Dialog.EndDialog();
		if( m_Self.onselect != null )
			m_Self.onselect();
	}
	else
	{
		m_Msg.MessageDlg( "メッセージ" , "タイトル名が設定されていません" , CAUTION_ICON | YES_BUTTON );
	}
}
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnCancel		= function()
{
	m_Dialog.EndDialog();
//	if( m_Self.ondialogend != null )
//		m_Self.ondialogend( CANCEL_BUTTON );
}
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnTextMouseDown		= function
		(
		args
		)
{
	m_Doc.getElementById( m_Id + "_textfield" ).focus();
}
	// イベント　
	this.onselect		= null;
	
	// データ
	var		m_IconId	= 0;
	var		m_ContentName	= "";
	
	// ビュー
	var		m_Iconnum	= 30;
	var		m_Msg		= new MessageDlg
			(
			msgbox_folder, 
			sd_folder
			);
	var		m_Dialog	= new DialogView
			(
			msgbox_folder + "/dlg_0_0.png" , 
			msgbox_folder + "/dlg_0_1.png" , 
			msgbox_folder + "/dlg_0_2.png" , 
			msgbox_folder + "/dlg_1_0.png" , 
			msgbox_folder + "/dlg_1_1.png" , 
			msgbox_folder + "/dlg_1_2.png" , 
			msgbox_folder + "/dlg_2_0.png" , 
			msgbox_folder + "/dlg_2_1.png" , 
			msgbox_folder + "/dlg_2_2.png" , 
			sd_folder
			);
	// iconbutton
	var		m_Icons	= null;
	{
		var		openlist = new Array( m_Iconnum );
		var		closelist= new Array( m_Iconnum );
		for( i = 0 ; i < m_Iconnum ; i++ )
		{
			openlist[ i ] = icon_folder + "/" + i + "_open.png";
			closelist[ i ] = icon_folder + "/" + i + "_close.png";
		}
		m_Icons = new IconSelectButton
			( 
			menu_folder + "/menu_0_0.png" , 
			menu_folder + "/menu_0_1.png" , 
			menu_folder + "/menu_0_2.png" , 
			menu_folder + "/menu_1_0.png" , 
			menu_folder + "/menu_1_1.png" , 
			menu_folder + "/menu_1_2.png" , 
			menu_folder + "/menu_2_0.png" , 
			menu_folder + "/menu_2_1.png" , 
			menu_folder + "/menu_2_2.png" , 
			sd_folder , 
			5 , 
			closelist , 
			openlist
		);
	}
	var		m_Yes		= new ButtonView
			(
			msgbox_folder + "/yes_0.png" , 
			msgbox_folder + "/yes_1.png" , 
			msgbox_folder + "/yes_2.png" , 
			null , 
			this.OnYes , 
			"push"
			);		
	var		m_Cancel		= new ButtonView
			(
			msgbox_folder + "/cancel_0.png" , 
			msgbox_folder + "/cancel_1.png" , 
			msgbox_folder + "/cancel_2.png" , 
			null , 
			this.OnCancel , 
			"push"
			);		
	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "ContentEditDlg_" + GetUniqueId();
	var		m_Doc				= null;
	
// private function define
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent			//!< [in] root dom
		)
{
	var	div	= parent.appendChild( m_Doc.createElement( "div" ) );
	div.setAttribute( "align" , "center" );
//	div.appendChild( m_Doc.createElement("br") );
	{
		var	table	= div.appendChild( m_Doc.createElement( "table" ) );
		{
			table.border	= 0;
					
			var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
			{
				var	tr 		= tbody.appendChild( m_Doc.createElement( "tr" ) );
				{
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						{
							td.style.padding = "5px";
							var	ddiv	= td.appendChild( m_Doc.createElement( "div" ) );
							ddiv.style.whiteSpace = "nowrap";
							ddiv.appendChild( m_Doc.createTextNode( "アイコン" ) );
						}
					}
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						{
							td.appendChild( m_Icons.CreateDOM( m_Doc ) );
						}
					}
				}
				var	tr 		= tbody.appendChild( m_Doc.createElement( "tr" ) );
				{
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						{
							td.style.padding = "5px";
							var	ddiv	= td.appendChild( m_Doc.createElement( "div" ) );
							ddiv.style.whiteSpace = "nowrap";
							ddiv.appendChild( m_Doc.createTextNode( "タイトル名" ) );
						}
					}
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						{
							var	text = td.appendChild( m_Doc.createElement( "input" ) );
							text.setAttribute( "id" , m_Id + "_textfield" );
							text.setAttribute( "unselectable" , "off" );
							text.setAttribute( "type" , "text" );
							text.setAttribute( "size" , "30" );
							text.setAttribute( "maxlength" , "30" );
							text.onmousedown=new CallbackAdapt( m_Self.OnTextMouseDown ).exec;
							text.value = m_ContentName;
						}
					}
				}
			}
		}
	}
	div.appendChild( m_Doc.createElement("br") );
	// buttons
	{
		var	table	= div.appendChild( m_Doc.createElement( "table" ) );
		{
			table.border	= 0;
					
			var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
			{
				var	tr 		= tbody.appendChild( m_Doc.createElement( "tr" ) );
				{
					// yes
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						td.appendChild( m_Yes.CreateDOM( m_Doc ) );
					}
					// cancel
					{
						var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
						td.appendChild( m_Cancel.CreateDOM( m_Doc ) );
					}
				}
			}
		}
	}
}

// public functions define
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc	= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	MessageDlg
//!	@retval			---
//-----------------------------------------------------------------------
this.Dialog = function
		(
		dlg_title , 
		icon_id , 
		content_name		
		)
{
	m_IconId		= icon_id;
	m_ContentName	= content_name;
	
	m_Icons.SetSelect( m_IconId );
	m_Dialog.SetView( m_Self );
	m_Dialog.SetTitleView( new HtmlView( '<font color="#FFFFFF" >' + dlg_title + '</font>' ) );
	m_Dialog.Dialog();
}
//=======================================================================
//! get iconid	
//!	@retval			---
//-----------------------------------------------------------------------
this.GetIconId = function()
{
	return m_IconId;
}
//=======================================================================
//! get content name	
//!	@retval			---
//-----------------------------------------------------------------------
this.GetContentName = function()
{
	return m_ContentName;
}
}


/****************************************************************************
"TreeEditor" class 
****************************************************************************/
/////////////////////////////////////////////////////////////////////////////
function TreeEditor
		(
		imgpath
		)
{
// event function define
//=======================================================================
//!OnItemSelect	
//!	@retval			---
//-----------------------------------------------------------------------
this.OnItemPreSelect = function
		(
		it
		)
{
	var next_html = m_EditorView.GetHtml();
	if( ( it != null ) && ( it.m_Parent != null ) && ( it.m_Html != null ) && ( it.m_Html != next_html ) && ( it.m_UUID != "root" ) )
	{
		if( m_Self.onupdatedocument != null )
			m_Self.onupdatedocument( it.m_UUID , next_html );
	}
	if( it == null )
		return null;
	if( it.m_UUID == "root" )
		return null;
	if( it.m_Html == null )
		return null;
	return next_html;
}
//=======================================================================
//!	OnItemSleect
//!	@retval			---
//-----------------------------------------------------------------------
this.OnItemSelect = function
		(
		it
		)
{
	if( ( it.m_Html == null ) && ( it.m_Parent != null ) )
	{
		if( m_Self.onneeddocument != null )
			m_Self.onneeddocument( it.m_UUID );
	}
	if( it.m_Html == null )
	{
		m_EditorView.SetHtml( "" );
		m_EditorView.Show( false );
	}
	else
	{
		m_EditorView.SetHtml( it.m_Html );
		m_EditorView.Show( true );
	}
}
//=======================================================================
//!	OnUpdateState
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUpdateState	= function()
{
	m_Bold.SetState( true == m_EditorView.IsBold() ? 1 : 0 );
	m_Italic.SetState( true == m_EditorView.IsItalic() ? 1 : 0 );
	m_Under.SetState( true == m_EditorView.IsUnderline() ? 1 : 0 );
	m_Left.SetState( true == m_EditorView.IsLeftAlign() ? 1 : 0 );
	m_Center.SetState( true == m_EditorView.IsCenterAlign() ? 1 : 0 );
	m_Right.SetState( true == m_EditorView.IsRightAlign() ? 1 : 0 );
	m_Sizelist.SetSelect( m_EditorView.GetFontSize() );
	m_Fontlist.SetSelect( m_EditorView.GetFontName() );
//	alert( m_EditorView.GetFontSize() );
}
//=======================================================================
//!	OnExpand
//!	@retval			---
//-----------------------------------------------------------------------
this.OnExpand = function
		(
		it
		)
{
	if( it == null || m_Self.onexpand == null )
		return;
	if( it.m_Parent != null )
		m_Self.onexpand( it.m_UUID , it.m_Open );
}
//=======================================================================
//!	new_exe
//!	@retval			---
//-----------------------------------------------------------------------
this.OnNewExe	= function()
{
	var	it = m_Tree.NewItem( m_Edit.GetContentName() , m_Edit.GetIconId() );
	if( it == null || m_Self.onnew == null )
		return;
	it.m_Html	= "";
	m_EditorView.Show( true );
	m_EditorView.SetHtml( "" );

	//コールバック
	var	offset;
	for( offset = 0 ; offset < it.m_Parent.m_Children.length ; offset++ )
	{
		if( it.m_Parent.m_Children[ offset ] == it )
			break;
	}
	m_Self.onnew( it.m_Parent.m_UUID , offset , it.m_UUID , it.m_Title , it.m_Html , it.m_IconId , it.m_Open );
}
//=======================================================================
//!	new
//!	@retval			---
//-----------------------------------------------------------------------
this.OnNew		= function()
{
	if( m_Tree.GetItemnum() > m_Self.m_ItemnumMax )
	{
		m_OKDlg.MessageDlg( "メッセージ" , "作成できるドキュメント数は " + m_Self.m_ItemnumMax + " までです。" , YES_BUTTON | ERROR_ICON );
		return;		
	}
	m_Edit.onselect = m_Self.OnNewExe;
	m_Edit.Dialog( "ドキュメントの新規作成" , 0 , "new item" );	
}
//=======================================================================
//!	del
//!	@retval			---
//-----------------------------------------------------------------------
this.OnDelDialog		= function
		(
		button
		)
{
	if( button == YES_BUTTON )
	{
		var	uuid = m_Tree.DeleteItem();
		if( uuid != null && m_Self.ondelete != null )
			m_Self.ondelete( uuid );
		m_EditorView.Show( false );
	}
}
//=======================================================================
//!	del
//!	@retval			---
//-----------------------------------------------------------------------
this.OnDel		= function()
{
	m_DeleteMsgBox.MessageDlg( "メッセージ" , "ドキュメントを削除してもいいですか？" , YES_BUTTON | NO_BUTTON | CAUTION_ICON );
//	m_DeleteMsgBox.MessageDlg( "title" , "ドキュメントを削除してもいいですか？\nccccc" , YES_BUTTON | NO_BUTTON );
//	m_Tree.DeleteItem();
}
//=======================================================================
//!	left
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMoveLeft		= function()
{
	var		it = m_Tree.Leveldown();
	if( it == null )
		return;
	if( m_Self.onmove != null )
	{
		var	offset = 0;
		for( offset = 0 ; offset < it.m_Parent.m_Children.length ; offset++ )
		{
			if( it == it.m_Parent.m_Children[ offset ] )
				break;
		}
		m_Self.onmove( it.m_UUID , it.m_Parent.m_UUID , offset );
	}
}
//=======================================================================
//!	left
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMoveUp		= function()
{
	var	it = m_Tree.Moveup();
	if( it == null )
		return;
	if( m_Self.onmove != null )
	{
		var	offset = 0;
		for( offset = 0 ; offset < it.m_Parent.m_Children.length ; offset++ )
		{
			if( it == it.m_Parent.m_Children[ offset ] )
				break;
		}
		m_Self.onmove( it.m_UUID , it.m_Parent.m_UUID , offset );
	}
}
//=======================================================================
//!	left
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMoveRight		= function()
{
	var it = m_Tree.Levelup();
	if( it == null )
		return;
	if( m_Self.onmove != null )
	{
		var	offset = 0;
		for( offset = 0 ; offset < it.m_Parent.m_Children.length ; offset++ )
		{
			if( it == it.m_Parent.m_Children[ offset ] )
				break;
		}
		m_Self.onmove( it.m_UUID , it.m_Parent.m_UUID , offset );
	}
}
//=======================================================================
//!	left
//!	@retval			---
//-----------------------------------------------------------------------
this.OnMoveDown		= function()
{
	var it = m_Tree.Movedown();
	if( it == null )
		return;
	if( m_Self.onmove != null )
	{
		var	offset = 0;
		for( offset = 0 ; offset < it.m_Parent.m_Children.length ; offset++ )
		{
			if( it == it.m_Parent.m_Children[ offset ] )
				break;
		}
		m_Self.onmove( it.m_UUID , it.m_Parent.m_UUID , offset );
	}
}
//=======================================================================
//!	left
//!	@retval			---
//-----------------------------------------------------------------------
this.OnEditExe		= function()
{
	var		it = m_Tree.SetSelctItemInfo( m_Edit.GetIconId() , m_Edit.GetContentName() );
	if( ( it != null ) && ( m_Self.oneditinfo != null ) )
	{
		m_Self.oneditinfo( it.m_UUID , it.m_Title , it.m_IconId );
	}
}
//=======================================================================
//!	left
//!	@retval			---
//-----------------------------------------------------------------------
this.OnEdit		= function()
{
	var	iconid 	= m_Tree.GetSelectItemIconId();
	var	title	= m_Tree.GetSelectItemTitle();
	if( iconid == null )
		return;

	m_Edit.onselect = m_Self.OnEditExe;
	m_Edit.Dialog( "ドキュメントの編集" , iconid , title );	
}
//=======================================================================
//!	fontsize
//!	@retval			---
//-----------------------------------------------------------------------
this.OnFontsize		= function()
{
	var	size = m_Sizelist.GetSelect();
	m_EditorView.FontSize( size == -1 ? null : size );
}
//=======================================================================
//!	fontlist
//!	@retval			---
//-----------------------------------------------------------------------
this.OnFontlist		= function()
{
	var	font = m_Fontlist.GetSelect();
	m_EditorView.FontName( font );
}
//=======================================================================
//!	bold
//!	@retval			---
//-----------------------------------------------------------------------
this.OnBold		= function()
{
	m_EditorView.Bold( true );
}
//=======================================================================
//!	italic
//!	@retval			---
//-----------------------------------------------------------------------
this.OnItalic		= function()
{
	m_EditorView.Italic( true );
}
//=======================================================================
//!	under
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUnder		= function()
{
	m_EditorView.Underline( true );
}
//=======================================================================
//!	copy
//!	@retval			---
//-----------------------------------------------------------------------
this.OnCopy		= function()
{
	m_EditorView.Copy();
}
//=======================================================================
//!	cut
//!	@retval			---
//-----------------------------------------------------------------------
this.OnCut		= function()
{
	m_EditorView.Cut();
}
//=======================================================================
//!	paste
//!	@retval			---
//-----------------------------------------------------------------------
this.OnPaste		= function()
{
	m_EditorView.Paste();
}
//=======================================================================
//!	undo
//!	@retval			---
//-----------------------------------------------------------------------
this.OnUndo		= function()
{
	m_EditorView.Undo();
}
//=======================================================================
//!	redo
//!	@retval			---
//-----------------------------------------------------------------------
this.OnRedo		= function()
{
	m_EditorView.Redo();
}
//=======================================================================
//!	left
//!	@retval			---
//-----------------------------------------------------------------------
this.OnLeft		= function()
{
	m_EditorView.LeftAlign();
	m_Center.SetState( 0 );
	m_Right.SetState( 0 );
}
//=======================================================================
//!	center
//!	@retval			---
//-----------------------------------------------------------------------
this.OnCenter		= function()
{
	m_EditorView.CenterAlign();
	m_Left.SetState( 0 );
	m_Right.SetState( 0 );
}
//=======================================================================
//!	right
//!	@retval			---
//-----------------------------------------------------------------------
this.OnRight		= function()
{
	m_EditorView.RightAlign();
	m_Left.SetState( 0 );
	m_Center.SetState( 0 );
}
//=======================================================================
//!	indent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnIndent		= function()
{
	m_EditorView.Indent();
}
//=======================================================================
//!	outdent
//!	@retval			---
//-----------------------------------------------------------------------
this.OnOutdent		= function()
{
	m_EditorView.Outdent();
}
//=======================================================================
//!	textcolor
//!	@retval			---
//-----------------------------------------------------------------------
this.OnTextColor		= function()
{
	m_EditorView.TextColor( ColorToStr( m_TextColor.GetSelectColor() ) );
}
//=======================================================================
//!	about
//!	@retval			---
//-----------------------------------------------------------------------
this.OnAbout		= function()
{
	m_AboutDlg.Dialog();	
}
	//セッティング
	this.m_ItemnumMax		= 20;
	
	// イベント
	this.onnew				= null;
	this.onexpand			= null;
	this.ondelete			= null;
	this.onupdatedocument	= null;
	this.onneeddocument		= null;
	this.oneditinfo			= null;
	this.onmove				= null;
	
	// image path
	var		m_ImgPath = imgpath;

	// parts	
	var		m_Pad		= new ImgView( imgpath + "/pad.png" );
	var		m_Separator	= new ImgView( imgpath + "/separator.png" );

	// editor
	var		m_EditorView= new HtmlEditorView();
	m_EditorView.SetSize( "100%" , "100%" );
	m_EditorView.onupdate	= this.OnUpdateState;
	
	// fontlist
	var		m_Fontlist	= new ComboView( "文字のフェイスの設定" );
	m_Fontlist.AddItems( new Array( "ＭＳ 明朝" , "ＭＳ ゴシック" , "MS UI Gothic" , "Trebuchet MS" , "Verdana" ) , new Array( "ＭＳ 明朝" , "ＭＳ ゴシック" , "MS UI Gothic" , "Trebuchet MS" , "Verdana" ) );
 	m_Fontlist.onchange = this.OnFontlist; 
	
	// sizelist
	var		m_Sizelist	= new ComboView( "文字のサイズの設定" );
	m_Sizelist.AddItems( new Array( "8pt" , "10pt" , "12pt" , "14pt" , "18pt" , "24pt" , "36pt" ) , new Array( 1 ,2 , 3 , 4 , 5 , 6 , 7 ) );
 	m_Sizelist.onchange = this.OnFontsize; 
 	
	// new
	var		m_New = new ButtonView( imgpath + "/new_pull.png" , imgpath + "/new_over.png" , imgpath + "/new_push.png" , "新規作成" , this.OnNew , "push" );

	// del
	var		m_Del = new ButtonView( imgpath + "/del_pull.png" , imgpath + "/del_over.png" , imgpath + "/del_push.png" , "削除" , this.OnDel , "push" );

	// moveleft
	var		m_MoveLeft = new ButtonView( imgpath + "/movleft_pull.png" , imgpath + "/movleft_over.png" , imgpath + "/movleft_push.png" , "レベルを下げる" , this.OnMoveLeft , "push" );
	// moveright
	var		m_MoveRight = new ButtonView( imgpath + "/movright_pull.png" , imgpath + "/movright_over.png" , imgpath + "/movright_push.png" , "レベルを上げる" , this.OnMoveRight , "push" );
	// moveright
	var		m_MoveUp = new ButtonView( imgpath + "/movup_pull.png" , imgpath + "/movup_over.png" , imgpath + "/movup_push.png" , "上に移動" , this.OnMoveUp , "push" );
	// moveright
	var		m_MoveDown = new ButtonView( imgpath + "/movdown_pull.png" , imgpath + "/movdown_over.png" , imgpath + "/movdown_push.png" , "下に移動" , this.OnMoveDown , "push" );
	// edit
	var		m_Edit = new ButtonView( imgpath + "/edit_pull.png" , imgpath + "/edit_over.png" , imgpath + "/edit_push.png" , "編集" , this.OnEdit , "push" );

	// bold
	var		m_Bold = new ButtonView( imgpath + "/bold_pull.png" , imgpath + "/bold_over.png" , imgpath + "/bold_push.png" , "ボールドの設定" , this.OnBold , "toggle" );

	// italic
	var		m_Italic = new ButtonView( imgpath + "/italic_pull.png" , imgpath + "/italic_over.png" , imgpath + "/italic_push.png" , "イタリックの設定" , this.OnItalic , "toggle" );

	// under
	var		m_Under = new ButtonView( imgpath + "/under_pull.png" , imgpath + "/under_over.png" , imgpath + "/under_push.png" , "アンダーバーの設定" , this.OnUnder , "toggle" );

	// copy
	var		m_Copy = new ButtonView( imgpath + "/copy_pull.png" , imgpath + "/copy_over.png" , imgpath + "/copy_push.png" , "テキストのコピー" , this.OnCopy );

	// cut
	var		m_Cut = new ButtonView( imgpath + "/cut_pull.png" , imgpath + "/cut_over.png" , imgpath + "/cut_push.png" , "テキストのカット" , this.OnCut );

	// paste
	var		m_Paste = new ButtonView( imgpath + "/paste_pull.png" , imgpath + "/paste_over.png" , imgpath + "/paste_push.png" , "貼り付け" , this.OnPaste );

	// undo
	var		m_Undo = new ButtonView( imgpath + "/undo_pull.png" , imgpath + "/undo_over.png" , imgpath + "/undo_push.png" , "元に戻す" , this.OnUndo );

	// redo
	var		m_Redo = new ButtonView( imgpath + "/redo_pull.png" , imgpath + "/redo_over.png" , imgpath + "/redo_push.png" , "やり直す" , this.OnRedo );

	// left
	var		m_Left = new ButtonView( imgpath + "/left_pull.png" , imgpath + "/left_over.png" , imgpath + "/left_push.png" , "左揃え" , this.OnLeft , "onepush" );

	// center
	var		m_Center = new ButtonView( imgpath + "/center_pull.png" , imgpath + "/center_over.png" , imgpath + "/center_push.png" , "中央揃え" , this.OnCenter , "onepush" );

	// right
	var		m_Right = new ButtonView( imgpath + "/right_pull.png" , imgpath + "/right_over.png" , imgpath + "/right_push.png" , "右揃え" , this.OnRight , "onepush" );

	// ind_off
	var		m_IndOff = new ButtonView( imgpath + "/ind_off_pull.png" , imgpath + "/ind_off_over.png" , imgpath + "/ind_off_push.png" , "インデント解除" , this.OnOutdent );

	// ind_on
	var		m_IndOn = new ButtonView( imgpath + "/ind_on_pull.png" , imgpath + "/ind_on_over.png" , imgpath + "/ind_on_push.png" , "インデント" , this.OnIndent );

	// about
	var		m_About = new ButtonView( imgpath + "/about_pull.png" , imgpath + "/about_over.png" , imgpath + "/about_push.png" , "WebNoteについて" , this.OnAbout );

	// textcolor
//	var		m_TextColor = new ButtonView( imgpath + "/textcolor_pull.png" , imgpath + "/textcolor_over.png" , imgpath + "/textcolor_push.png" , "テキストの色" , this.OnTextColor );
	var		m_TextColor = new ColorSelectButton
			( 
			imgpath + "/Menu/menu_0_0.png" , 
			imgpath + "/Menu/menu_0_1.png" , 
			imgpath + "/Menu/menu_0_2.png" , 
			imgpath + "/Menu/menu_1_0.png" , 
			imgpath + "/Menu/menu_1_1.png" , 
			imgpath + "/Menu/menu_1_2.png" , 
			imgpath + "/Menu/menu_2_0.png" , 
			imgpath + "/Menu/menu_2_1.png" , 
			imgpath + "/Menu/menu_2_2.png" , 
			imgpath + "/Shadow" , 
			imgpath + "/textcolor_pull.png" , 
			imgpath + "/textcolor_over.png" , 
			imgpath + "/textcolor_push.png" 
			);
	{
		m_TextColor.onselectcolor = this.OnTextColor;
	}
	// tree panel
	var		m_Tree				= new TreePanel
			(
			imgpath + "/TreeView"
			);
	{
		m_Tree.onexpand		= this.OnExpand;
		m_Tree.onpreselect 	= this.OnItemPreSelect;
		m_Tree.onselect	 	= this.OnItemSelect;	
//		m_Tree.SetItems( it );
	}
	var		m_iFrame			= new iFrameView
			(
			m_Tree
			);
	// toolbar
	var		m_Toolbar			= new ToolbarView
			(
			imgpath + "/toolbar_0_0.png" , 
			imgpath + "/toolbar_0_1.png" , 
			imgpath + "/toolbar_0_2.png" , 
			imgpath + "/toolbar_1_0.png" , 
			imgpath + "/toolbar_1_1.png" , 
			imgpath + "/toolbar_1_2.png" , 
			imgpath + "/toolbar_2_0.png" , 
			imgpath + "/toolbar_2_1.png" , 
			imgpath + "/toolbar_2_2.png"
			);
	m_Toolbar.AddViews
		(
		new Array
			(
			m_New , 
			m_Del , 
			m_MoveLeft , 
			m_MoveRight , 
			m_MoveUp , 
			m_MoveDown ,
			m_Edit ,  
			m_Separator , 
			m_Fontlist ,
			m_Pad , 
			m_Sizelist , 
			m_Separator , 
			m_Bold , 
			m_Italic , 
			m_Under , 
			m_Separator ,
			m_Copy , 
			m_Cut , 
			m_Paste , 
			m_Separator , 
			m_Undo , 
			m_Redo , 
			m_Separator  , 
			m_Left , 
			m_Center , 
			m_Right , 
			m_Separator , 
			m_IndOff , 
			m_IndOn , 
			m_Separator , 
			m_TextColor , 
			m_Separator , 
			m_About
			)
		);
	// edit
	var	 m_Edit = new ContentEditDlg
		(
		imgpath + "/MsgBox" , 
		imgpath + "/Menu" , 
		imgpath + "/Shadow" , 
		imgpath + "/TreeView" 
		);

	// ダイアログ関係
	var		m_AboutDlg	= new AboutDlg
		(
		imgpath + "/About" , 
		imgpath + "/MsgBox" , 
		imgpath + "/Shadow"
		);
	var		m_OKDlg		= new MessageDlg
			(
			imgpath + "/MsgBox" , 
			imgpath + "/Shadow"
			);
	var		m_DeleteMsgBox		= new MessageDlg
			(
			imgpath + "/MsgBox" , 
			imgpath + "/Shadow"
			);
	m_DeleteMsgBox.ondialogend	= this.OnDelDialog;

	// メンバ変数
	var		m_Self				= this;
	var 	m_Id				= "TreeEditor_" + GetUniqueId();
	var		m_Doc				= null;
	
// private function define
//=======================================================================
//! content	
//!	@retval			---
//-----------------------------------------------------------------------
function CreateContentDom
		(
		parent			//!< [in] root dom
		)
{
	var	table	= parent.appendChild( m_Doc.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
		table.setAttribute( "width" , "100%" );
		table.setAttribute( "height" , "100%" );
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
	// tree view
	{
		var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
		{
			var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
			{
				td.setAttribute( "height" , "100%" );
				td.setAttribute( "width" , "200" );
				
				td.appendChild( m_iFrame.CreateDOM( m_Doc ) );
			}
		}
		{
			var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
			{
				td.setAttribute( "background" , m_ImgPath + "/split.png" );
				var	img		= td.appendChild( m_Doc.createElement( "img" ) );
				{
					img.setAttribute( "src" , m_ImgPath + "/split.png" );
				}
//				td.setAttribute( "width" , "10" );
//				td.setAttribute( "height" , "10" );
//				td.appendChild( document.createTextNode( "a" ) );
			}
		}
		{
			var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
			{
				td.setAttribute( "width" , "100%" );
				td.setAttribute( "height" , "100%" );
//				td.setAttribute( "bgcolor" , "#3333FF" );
				td.appendChild( m_EditorView.CreateDOM( m_Doc ) );
			}
		}
	}
}
//=======================================================================
//!	DOM
//!	@retval			---
//-----------------------------------------------------------------------
function CreateDomUnderRoot
		(
		parent			//!< [in] root dom
		)
{
	var	table	= parent.appendChild( m_Doc.createElement( "table" ) );
	{
		table.border 		= 0; 
		table.cellSpacing 	= 0; 
		table.cellPadding 	= 0;
		table.setAttribute( "width" , "100%" );
		table.setAttribute( "height" , "100%" );
	}
	var	tbody	= table.appendChild( m_Doc.createElement( "tbody" ) );
	// toolbar
	{
		var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "height" , "1" );
		}
		td.appendChild( m_Toolbar.CreateDOM( m_Doc ) );
	}
	// editor
	{
		var	tr		= tbody.appendChild( m_Doc.createElement( "tr" ) );
		var	td		= tr.appendChild( m_Doc.createElement( "td" ) );
		{
			td.setAttribute( "height" , "100%" );
			CreateContentDom( td );
		}
	}
}

// public functions define
//=======================================================================
//!	アイテムの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetTree = function
		(
		itemtree
		)
{
	m_Tree.SetItems( itemtree );
}
//=======================================================================
//!	DOMの獲得
//!	@retval			---
//-----------------------------------------------------------------------
this.CreateDOM = function
		(
		doc
		)
{
	m_Doc		= doc;
	var	root	= m_Doc.createElement( "span" );
	root.setAttribute( "id" , m_Id );
		root.setAttribute( "width" , "100%" );
		root.setAttribute( "height" , "100%" );

	CreateDomUnderRoot( root );
	
	return root;
}
//=======================================================================
//!	ドキュメントの設定
//!	@retval			---
//-----------------------------------------------------------------------
this.SetDocument = function
		(
		uuid , 
		doc
		)
{
	if( true == m_Tree.SetDocument( uuid , doc ) )
	{
		m_EditorView.SetHtml( doc );
		m_EditorView.Show( true );
	}
}
//=======================================================================
//!	GetSelectDocument
//!	@retval			---
//-----------------------------------------------------------------------
this.Unload = function()
{
	var	it = m_Tree.GetSelect();
	var next_html = m_EditorView.GetHtml();
	if( ( it != null ) && ( it.m_Parent != null ) && ( it.m_Html != null ) && ( it.m_Html != next_html ) )
	{
		it.m_Html = next_html;
		if( m_Self.onunload != null )
			m_Self.onunload( it.m_UUID , next_html );
	}
}

}
